#! /bin/sh
# NOTE: Must have: correct Oracle database system password set, correct vap user password set, and correct Oracle Database SID value set.

sqlplus system/root@xe @BuildAll-Part1.sql

pushd LoaderData/CONSENT_AUDIT
sqlldr control=CONSENT_AUDIT_DATA_TABLE.ctl userid=vap/vap@xe
popd

pushd LoaderData/PATIENT_DOCUMENT
sqlldr control=PATIENT_DOCUMENT_DATA_TABLE.ctl userid=vap/vap@xe
popd

pushd LoaderData/PATIENT_FORM
sqlldr control=PATIENT_FORM_DATA_TABLE.ctl userid=vap/vap@xe
popd

sqlplus system/root@xe @BuildAll-Part2.sql

