CREATE TABLE VAP.ANNOUNCEMENT_ORGS
(
  ANNOUNCEMENT_ORG_ID  NUMBER                   NOT NULL,
  ORG_ID               NUMBER                   NOT NULL,
  ANNOUNCEMENT_ID      NUMBER                   NOT NULL,
  ANNOUNCE_RESULT      VARCHAR2(20 BYTE)
);


CREATE INDEX VAP.ANNOUNCEMENT_ORGS_IDX ON VAP.ANNOUNCEMENT_ORGS
(ORG_ID, ANNOUNCEMENT_ID);

CREATE UNIQUE INDEX VAP.ANNOUNCEMENT_ORGS_PK ON VAP.ANNOUNCEMENT_ORGS
(ANNOUNCEMENT_ORG_ID);

ALTER TABLE VAP.ANNOUNCEMENT_ORGS ADD (
  CONSTRAINT ANNOUNCEMENT_ORGS_PK
  PRIMARY KEY
  (ANNOUNCEMENT_ORG_ID)
  USING INDEX VAP.ANNOUNCEMENT_ORGS_PK
  ENABLE VALIDATE);
