CREATE TABLE VAP.PATIENT_COMMENT
(
  COMMENT_ID   NUMBER(19)                       NOT NULL,
  USER_ID      VARCHAR2(255 BYTE)               NOT NULL,
  DATE_ADDED   TIMESTAMP(6)                     NOT NULL,
  COMMENTS     CLOB                             NOT NULL,
  PATIENT_IEN  VARCHAR2(255 BYTE)               NOT NULL
);


CREATE UNIQUE INDEX VAP.PATIENT_COMMENT_PK ON VAP.PATIENT_COMMENT
(COMMENT_ID);

ALTER TABLE VAP.PATIENT_COMMENT ADD (
  CONSTRAINT PATIENT_COMMENT_PK
  PRIMARY KEY
  (COMMENT_ID)
  USING INDEX VAP.PATIENT_COMMENT_PK
  ENABLE VALIDATE);
