#!/bin/bash

export CLASSPATH="config/vap/*:$CLASSPATH

#Note: change domain path and .out file name below per environment domain
export DOMAIN_HOME="/u01/app/domains/vap_devl"
export VAP_CONFIG="$DOMAIN_HOME/config"
#export JAVA_OPTIONS="-Djava.security.egd=file:/dev/./urandom -Dweblogic.security.SSL.minimumProtocolVersion=TLSv1 -Dgov.va.med.environment.servertype=weblogic -Dorg.owasp.esapi.resources=/u01/app/domains/vap_devl/config/vap/esapi -Djava.util.logging.config.file=/u01/app/domains/vap_devl/config/vap/logging.properties -Dlog4j.configuration=file:///u01/app/domains/vap_devl/config/vap/log4j.xml -Dext.properties.dir=/u01/app/domains/vap_devl/config/vap/ $JAVA_OPTIONS"
export JAVA_OPTIONS="-Djava.security.egd=file:/dev/./urandom -Dweblogic.security.SSL.minimumProtocolVersion=TLSv1 -Dgov.va.med.environment.servertype=weblogic -Dorg.owasp.esapi.resources=$VAP_CONFIG/vap/esapi -Djava.util.logging.config.file=$VAP_CONFIG/vap/logging.properties -Dlog4j.configuration=file://$VAP_CONFIG/vap/log4j.xml -Dext.properties.dir=$VAP_CONFIG/vap/ $JAVA_OPTIONS"
# Uncomment this to start with the debugger listening.
export JAVA_OPTIONS="-Xdebug -Xnoagent -Xrunjdwp:transport=dt_socket,address=4000,server=y,suspend=n $JAVA_OPTIONS"
nohup ./startWebLogic.sh &> vap_devl.out &

