/*
 * Tests Emailer class. 
 *
 */
package gov.va.nvap.server.test.service.privacy.emailer;


import gov.va.nvap.server.service.privacy.emailer.Emailer;
import java.util.HashMap;
import java.util.Map;

import org.junit.Test;
import org.junit.Assert;
import org.junit.Ignore;
import org.slf4j.LoggerFactory;
import org.slf4j.Logger;


/**
 *
 * Note: Need to setup a gmail user id possibly 
 * with username and password in .properties file to get the email to send.
 * 
 */
@Ignore
public class EmailerTest {
    
    private static final Logger LOG = LoggerFactory.getLogger(EmailerTest.class);
    
    @Test
    public void testEmailReport() throws Exception {
        boolean success = false;
        try {

            String bodyString = "Test report email contents!!!!"; 
            Map<String, String> messageAttributes = new HashMap<>();
            messageAttributes.put("subject", "VAP Test Email From TestEmailer JUnit class");
            messageAttributes.put("body", bodyString);
            
            String distributionList = "PII             ";

            Emailer emailer = new Emailer();  
            //    final public boolean emailReport(String distributionList, Map<String, String> messageAttributes, List<Map<String, Object>> report)
            success = emailer.emailReport(distributionList, messageAttributes, null);
            LOG.info("success:"+success);

        } catch (Exception e) {
            //e.printStackTrace();
            LOG.error("",e);
        }
        Assert.assertTrue(success);        
    }    
    
}
