package gov.va.nvap.web.dao;

import gov.va.nvap.web.visn.Visn;
import java.util.ArrayList;
import java.util.List;
import javax.persistence.EntityManager;
import javax.persistence.NoResultException;
import javax.persistence.PersistenceContext;
import javax.persistence.Query;
import javax.persistence.TypedQuery;

/**
 *
 * @author Irakli Kakushadze
 * @since 05/16/2016
 */
public class VisnDAO {

    @PersistenceContext
    private EntityManager em;

    public void setEntityManager(EntityManager entityManager) {
        this.em = entityManager;
    }
    
    public List<Visn> findAll() {
        try {
            final TypedQuery<Visn> q = this.em.createNamedQuery("Visn.findAll", Visn.class);
            return q.getResultList();
        } catch (final NoResultException nre) {
            return new ArrayList<Visn>();
        }
    }
    
}
