package gov.va.nvap.web.user;

import javax.servlet.http.HttpServletRequest;

import org.slf4j.LoggerFactory;
import org.slf4j.Logger;

/**
 *
 * @author Zack Peterson
 */
public class UserHelper {

    private static final Logger LOG = LoggerFactory.getLogger(UserHelper.class);
    
    private static final String VA_USERNAME = "adSamAccountName";

    public static String getUserName(HttpServletRequest request) {
        if (request != null) {
            if (request.getSession() != null && request.getSession().getAttribute("user") != null) {
                return ((User)request.getSession().getAttribute("user")).getName();
            } else if (request.getAttribute(VA_USERNAME) != null) {
                return (String)request.getAttribute(VA_USERNAME);
            }
        }

        return "";
    }
}