/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package gov.va.nvap.web.util;

import gov.va.nvap.svc.consentmgmt.stub.dao.DescriptorDAO;
import gov.va.nvap.svc.consentmgmt.stub.data.Descriptor;
import java.io.IOException;
import java.text.ParseException;
import java.util.HashMap;
import java.util.List;
import javax.servlet.ServletContext;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
 *
 * @author johannsonnenberg
 */
public class TooltipHandler extends gov.va.nvap.web.app.ResponseDispatcherHttpServlet {
    
    private static final long serialVersionUID = 1L;
    
    private DescriptorDAO getDescriptorDAO() {
        return this.getBean("DescriptorDAO", DescriptorDAO.class);
    }
    
    @Override
    public void unspecified(final HttpServletRequest request, final HttpServletResponse response) throws ServletException, IOException {
        
    }
    
    public void reload(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException, ParseException {
        int tooltipCount = this.addDescriptors(request.getServletContext());
        
        request.setAttribute("tooltipCount", tooltipCount);
        
        this.forward(request, response, "reload");
    }
    
    private int addDescriptors(ServletContext sc) {
        List<Descriptor> dees = getDescriptorDAO().getAll();
        
        HashMap<String, String> hm = new HashMap<String, String>();

        for(Descriptor d : dees) {
            hm.put(d.getName(), d.getText());
        }
        
        sc.setAttribute("descriptors", hm);
        
        return hm.size();
    }
}
