<%--
    Document   : View Document - When the user clicks on the View link from the GUI in reports
    Author     : Asha Amritraj
--%>

<%@taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c"%>
<%@taglib tagdir="/WEB-INF/tags/formatting" prefix="f" %>
<%@taglib tagdir="/WEB-INF/tags/cpp" prefix="cpp"%>

<f:mainTemplate headerText="Document View">
    <script type="text/javascript">
        $(document).ready(function () {
            $('#contact-info').addClass('margin-bottom-30'); //it's a hack i know, but this gives the last element in this xml a bottom margin so it doesn't get lost behind the footer
        });
    </script>
    
    <link rel="stylesheet" type="text/css" href="resources/css/c32/xmlverbatim.css" />
    <link rel="stylesheet" type="text/css" href="resources/css/c32/cda.css" />
    <link rel="stylesheet" type="text/css" href="resources/css/c32/adapter.css" />
    <link rel="stylesheet" type="text/css" href="resources/css/c32/custom_cda.css" />
    <div>
        <div class="no-print text-right">
            <c:if test="${isXmlViewEnabled}">
                <c:url var="xmlToHtmlStyleSheet" value="DocumentDisclosureReport.do_sec">
                    <c:param name="view" value="true" />
                    <c:param name="documentIcn" value="${icn}" />
                    <c:param name="documentUniqueId" value="${documentUniqueId}" />
                    <c:param name="styleSheetViewType" value="xml" />
                </c:url>
                <a title="View XML" href="<c:out value="${xmlToHtmlStyleSheet}"/>" class="pad-right-10"><i class="fa fa-download fa-2x" aria-hidden="true"></i> View XML</a>
            </c:if>
            <a title="Print Document" href="javascript:window.print();">
                <i class="fa fa-print fa-2x" aria-hidden="true"></i> Print
            </a>
        </div>
    </div>
    <div class="pad-bottom-20">
        <!-- document content -->
        <c:out value="${updatedDocument}" escapeXml="false" />
    </div>
</f:mainTemplate>