<%--
    Document   : debug setting change page
    Created on : 07/18/2016
    Author     : Johann Sonnenberg
--%>

<%@taglib tagdir="/WEB-INF/tags/formatting" prefix="f" %>
<%@taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c" %>

<f:mainTemplate headerText="Global Error Handling Debugging Changed">
    <div class="row">
        <div class="col-xs-12 col-sm-12 col-md-12 col-lg-12">
            <div class="alert alert-warning">
                <c:choose>
                    <c:when test="${debug}">
                        <p>Debug has been set to <strong>TRUE</strong>. This means you will see the stack trace of an error. This is only for your session.</p>
                        <p>If you log out, you will need to turn this on again should you require it in your next session.</p>
                    </c:when>
                    <c:otherwise>
                        <p>Debug has been set to <strong>FALSE</strong>. This means you will not see the stack trace of an error, you will see the friendly error message.</p>
                        <p>This is what the default global error handling is set to.</p>
                    </c:otherwise>
                </c:choose>
            </div>
        </div>
    </div>
</f:mainTemplate>