<%-- 
    Document   : shows the restrictions for a patient who has opted in
    Created on : Feb 22, 2017, 10:52:53 AM
    Author     : Johann P. Sonnenberg
--%>
<%@taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c"%>
<%@taglib uri="http://java.sun.com/jsp/jstl/functions" prefix="fn"%>

<div>
    <div class="alert alert-info">
        The Veteran restricted sharing of electronic health information with the following organizations.
    </div>
    <c:choose>
        <c:when test="${not empty message}">
            <div class="alert alert-danger margin-top-10">
                <c:out value="${message}" />
            </div>
        </c:when>
        <c:otherwise>
            <c:choose>
                <c:when test="${not empty excludedOrganizations}">
                    <table class="table table-striped">
                        <thead>
                            <tr>
                                <th>Restricted Organization</th>
                            </tr>
                        </thead>
                        <tbody>
                            <c:forEach items="${excludedOrganizations}" var="eo">
                                <tr>
                                    <td><c:out value="${eo.orgName}" /></td>
                                </tr>
                            </c:forEach>
                        </tbody>
                    </table>
                </c:when>
                <c:otherwise>
                    No restricted organizations found.
                </c:otherwise>
            </c:choose>
        </c:otherwise>
    </c:choose>
</div>