/*
 * NOTE: This is a fork off of the datepicker.js file. The if statements in the min and max methods gave incorrect results. 
 *       The other change was to change the aria-labelledby="datepicker-bn-open-label-CALENDARID" to aria-label="Select Date...".
 *       01-05-2018 - JPS - changed the triggering of the ab.datepicker.opening event to use self.id as it was incorrectly targeting the datepicker input
 *       06-14-2018 - JPS - updated to version 2.1.10 and made the required VAP edits to the updated version
 *       The datepicker.vap.min.js is what is now included in the mainTemplate.tag. 
 *       If you make changes here, you must minify it and place it into the datepicker.vap.min.js file. 
 * 
 * Author: Johann P. Sonnenberg
 * 
 */
(function(){"use strict";if(typeof Date.dp_locales==='undefined'){Date.dp_locales={"texts":{"buttonTitle":"Select date ...","buttonLabel":"Click or press the Enter key or the spacebar to open the calendar","prevButtonLabel":"Go to previous month","prevMonthButtonLabel":"Go to the previous year","prevYearButtonLabel":"Go to the previous twenty years","nextButtonLabel":"Go to next month","nextMonthButtonLabel":"Go to the next year","nextYearButtonLabel":"Go to the next twenty years","changeMonthButtonLabel":"Click or press the Enter key or the spacebar to change the month","changeYearButtonLabel":"Click or press the Enter key or the spacebar to change the year","changeRangeButtonLabel":"Click or press the Enter key or the spacebar to go to the next twenty years","closeButtonTitle":"Close","closeButtonLabel":"Close the calendar","calendarHelp":"- Up Arrow and Down Arrow - goes to the same day of the week in the previous or next week respectively. If the end of the month is reached, continues into the next or previous month as appropriate.\r\n- Left Arrow and Right Arrow - advances one day to the next, also in a continuum. Visually focus is moved from day to day and wraps from row to row in the grid of days.\r\n- Control+Page Up - Moves to the same date in the previous year.\r\n- Control+Page Down - Moves to the same date in the next year.\r\n- Home - Moves to the first day of the current month.\r\n- End - Moves to the last day of the current month.\r\n- Page Up - Moves to the same date in the previous month.\r\n- Page Down - Moves to the same date in the next month.\r\n- Enter or Espace - closes the calendar, and the selected date is shown in the associated text box.\r\n- Escape - closes the calendar without any action."},"directionality":"LTR","month_names":["January","February","March","April","May","June","July","August","September","October","November","December"],"month_names_abbreviated":["Jan","Feb","Mar","Apr","May","Jun","Jul","Aug","Sep","Oct","Nov","Dec"],"month_names_narrow":["J","F","M","A","M","J","J","A","S","O","N","D"],"day_names":["Sunday","Monday","Tuesday","Wednesday","Thursday","Friday","Saturday"],"day_names_abbreviated":["Sun","Mon","Tue","Wed","Thu","Fri","Sat"],"day_names_short":["Su","Mo","Tu","We","Th","Fr","Sa"],"day_names_narrow":["S","M","T","W","T","F","S"],"day_periods":{"am":"AM","noon":"noon","pm":"PM"},"day_periods_abbreviated":{"am":"AM","noon":"noon","pm":"PM"},"day_periods_narrow":{"am":"a","noon":"n","pm":"p"},"quarter_names":["1st quarter","2nd quarter","3rd quarter","4th quarter"],"quarter_names_abbreviated":["Q1","Q2","Q3","Q4"],"quarter_names_narrow":["1","2","3","4"],"era_names":["Before Christ","Anno Domini"],"era_names_abbreviated":["BC","AD"],"era_names_narrow":["B","A"],"full_format":"EEEE, MMMM d, y","long_format":"MMMM d, y","medium_format":"MMM d, y","short_format":"M/d/yy","firstday_of_week":0}}})();(function(factory){if(typeof define==="function"&&define.amd){define(["jquery"],factory)}else if(typeof exports==='object'){factory(require('jquery'))}else{if(typeof jQuery==='undefined'){throw new Error('Datepicker\'s JavaScript requires jQuery')}
factory(jQuery)}}(function($,undefined){'use strict';var datepickerButton=['<a class="datepicker-button input-group-addon btn" role="button" aria-haspopup="true" tabindex="0" aria-label="Select date...">','	<span class="glyphicon glyphicon-calendar" title="Select Date..."></span>','</a>'];var datepickerCalendar=['<div class="datepicker-calendar" id="datepicker-calendar-CALENDARID" aria-hidden="false">','	<div class="datepicker-month-wrap">','		<div class="datepicker-month-fast-next pull-right" role="button" aria-labelledby="datepicker-bn-fast-next-label-CALENDARID" tabindex="0"><span class="glyphicon glyphicon-forward"></span></div>','		<div class="datepicker-month-next pull-right" role="button" aria-labelledby="datepicker-bn-next-label-CALENDARID" tabindex="0"><span class="glyphicon glyphicon-triangle-right"></span></div>','		<div class="datepicker-month-fast-prev pull-left" role="button" aria-labelledby="datepicker-bn-fast-prev-label-CALENDARID" tabindex="0"><span class="glyphicon glyphicon-backward"></span></div>','		<div class="datepicker-month-prev pull-left" role="button" aria-labelledby="datepicker-bn-prev-label-CALENDARID" tabindex="0"><span class="glyphicon glyphicon-triangle-left"></span></div>','		<div id="datepicker-month-CALENDARID" class="datepicker-month" tabindex="0" role="heading" aria-live="assertive" aria-atomic="true" title="Click or press the Enter key or the spacebar to change the month">July 2015</div>','	</div>','	<table class="datepicker-grid" role="grid" aria-readonly="true" aria-activedescendant="datepicker-err-msg-CALENDARID" aria-labelledby="datepicker-month-CALENDARID" tabindex="0">','		<thead role="presentation">','			<tr class="datepicker-weekdays" role="row">','				<th scope="col" id="day0-header-CALENDARID" class="datepicker-day" role="columnheader" aria-label="Sunday"><abbr title="Sunday">Su</abbr></th>','				<th scope="col" id="day1-header-CALENDARID" class="datepicker-day" role="columnheader" aria-label="Monday"><abbr title="Monday">Mo</abbr></th>','				<th scope="col" id="day2-header-CALENDARID" class="datepicker-day" role="columnheader" aria-label="Tuesday"><abbr title="Tuesday">Tu</abbr></th>','				<th scope="col" id="day3-header-CALENDARID" class="datepicker-day" role="columnheader" aria-label="Wednesday"><abbr title="Wednesday">We</abbr></th>','				<th scope="col" id="day4-header-CALENDARID" class="datepicker-day" role="columnheader" aria-label="Thursday"><abbr title="Thursday">Th</abbr></th>','				<th scope="col" id="day5-header-CALENDARID" class="datepicker-day" role="columnheader" aria-label="Friday"><abbr title="Friday">Fr</abbr></th>','				<th scope="col" id="day6-header-CALENDARID" class="datepicker-day" role="columnheader" aria-label="Saturday"><abbr title="Saturday">Sa</abbr></th>','			</tr>','		</thead>','		<tbody role="presentation">','			<tr>','				<td id="datepicker-err-msg-CALENDARID" colspan="7">Javascript must be enabled</td>','			</tr>','		</tbody>','	</table>','	<div class="datepicker-close-wrap">','		<button class="datepicker-close" id="datepicker-close-CALENDARID" aria-labelledby="datepicker-bn-close-label-CALENDARID">Close</button>','	</div>','	<div id="datepicker-bn-open-label-CALENDARID" class="datepicker-bn-open-label offscreen">Click or press the Enter key or the spacebar to open the calendar</div>','	<div id="datepicker-bn-prev-label-CALENDARID" class="datepicker-bn-prev-label offscreen">Go to previous month</div>','	<div id="datepicker-bn-next-label-CALENDARID" class="datepicker-bn-next-label offscreen">Go to next month</div>','	<div id="datepicker-bn-fast-prev-label-CALENDARID" class="datepicker-bn-fast-prev-label offscreen">Go to previous year</div>','	<div id="datepicker-bn-fast-next-label-CALENDARID" class="datepicker-bn-fast-next-label offscreen">Go to next year</div>','	<div id="datepicker-bn-close-label-CALENDARID" class="datepicker-bn-close-label offscreen">Close the date picker</div>','</div>'];var Datepicker=function(target,options){var self=this;this.$target=$(target);this.options=$.extend({},Datepicker.DEFAULTS,options)
this.locales=Date.dp_locales;this.startview(this.options.startView);if(typeof this.options.inputFormat==='string'){this.options.inputFormat=[this.options.inputFormat]}
if(!$.isArray(this.options.datesDisabled)){this.options.datesDisabled=[this.options.datesDisabled]}
$.each(this.options.datesDisabled,function(i,v){if(typeof v==='string'){var date=self.parseDate(v);if(date===null){self.options.datesDisabled[i]=null}else{self.options.datesDisabled[i]=self.format(date)}}else if(v instanceof Date&&!isNaN(v.valueOf())){self.options.datesDisabled[i]=self.format(v)}else{self.options.datesDisabled[i]=null}});if(this.options.min!=null){this.options.min=this.parseDate(this.options.min)}else if(this.$target.attr('min')){this.options.min=this.parseDate(this.$target.attr('min'))}
if(this.options.max!=null){this.options.max=this.parseDate(this.options.max)}else if(this.$target.attr('max')){this.options.max=this.parseDate(this.$target.attr('max'))}
if(typeof this.options.previous==='string'){this.options.previous=$(this.options.previous)}else if(!(this.options.previous instanceof jQuery)){this.options.previous=null}
if(typeof this.options.next==='string'){this.options.next=$(this.options.next)}else if(!(this.options.next instanceof jQuery)){this.options.next=null}
this.id=this.$target.attr('id')||'datepicker-'+Math.floor(Math.random()*100000);var calendar=datepickerCalendar.join("");calendar=calendar.replace(/CALENDARID/g,this.id+'');if(this.$target.parent('.input-group').length==0){this.$target.wrap('<div class="input-group"></div>')}
this.$label=this.$target.parents().find("label[for="+this.id+"]");this.$group=this.$target.parent('.input-group');this.$target.attr('aria-autocomplete','none')
this.$target.css('min-width','7em')
this.$target.addClass('form-control');if(!this.$target.attr('placeholder')){this.$target.attr('placeholder',this.options.inputFormat[0])}
var button=datepickerButton.join("");button=button.replace(/CALENDARID/g,this.id+'');this.$button=$(button);this.$button.addClass(this.options.theme);this.$calendar=$(calendar);this.$calendar.addClass(this.options.theme);this.$target.after(this.$button);if(this.$calendar.parent().css('position')==='static'){this.$calendar.parent().css('position','relative')}
this.$calendar.find('.datepicker-bn-open-label').html(this.options.buttonLabel);if(this.$target.attr('id')){this.$calendar.attr('aria-controls',this.$target.attr('id'))}
this.$button.find('span').attr('title',this.options.buttonTitle);this.$calendar.css('left',this.$target.parent().position().left+'px');this.$monthObj=this.$calendar.find('.datepicker-month');this.$prev=this.$calendar.find('.datepicker-month-prev');this.$next=this.$calendar.find('.datepicker-month-next');this.$fastprev=this.$calendar.find('.datepicker-month-fast-prev');this.$fastnext=this.$calendar.find('.datepicker-month-fast-next');this.$grid=this.$calendar.find('.datepicker-grid');if(this.locales.directionality==='RTL'){this.$grid.addClass('rtl')}
var $days=this.$grid.find('th.datepicker-day abbr');this.drawCalendarHeader();if(this.options.inline==!1&&this.options.modal==!0){this.$close=this.$calendar.find('.datepicker-close');this.$close.html(this.options.closeButtonTitle).attr('title',this.options.closeButtonLabel);this.$calendar.find('.datepicker-bn-close-label').html(this.options.closeButtonLabel)}else{this.hideObject(this.$calendar.find('.datepicker-close-wrap'));this.hideObject(this.$calendar.find('.datepicker-bn-close-label'))}
if(this.options.inline!=!1){this.hideObject(this.$button);var $container=typeof this.options.inline==='string'?$('#'+this.options.inline):this.options.inline;$container.append(this.$calendar);this.$calendar.css({position:'relative',left:'0px'});this.initializeDate()}else{this.$calendar.css({display:'none'});this.$target.parent().after(this.$calendar);this.hide(!this.options.gainFocusOnConstruction)}
this.keys={tab:9,enter:13,esc:27,space:32,pageup:33,pagedown:34,end:35,home:36,left:37,up:38,right:39,down:40};this.bindHandlers();this.$button.click(function(e){if(!$(this).hasClass('disabled')){if(self.$calendar.attr('aria-hidden')==='true'){self.initializeDate();self.show()}else{self.hide()}
self.selectGridCell(self.$grid.attr('aria-activedescendant'))}
e.stopPropagation();return!1});this.$button.keydown(function(e){var ev=e||event;if(ev.keyCode==self.keys.enter||ev.keyCode==self.keys.space){$(this).trigger('click');return!1}});this.$calendar.on('blur',function(e){if(self.$calendar.attr('aria-hidden')==='false'){self.hide()}})}
Datepicker.VERSION='2.1.10'
Datepicker.DEFAULTS={firstDayOfWeek:Date.dp_locales.firstday_of_week,weekDayFormat:'short',startView:0,daysOfWeekDisabled:[],datesDisabled:[],isDateDisabled:null,isMonthDisabled:null,isYearDisabled:null,inputFormat:[Date.dp_locales.short_format],outputFormat:Date.dp_locales.short_format,titleFormat:Date.dp_locales.full_format,buttonTitle:Date.dp_locales.texts.buttonTitle,buttonLabel:Date.dp_locales.texts.buttonLabel,prevButtonLabel:Date.dp_locales.texts.prevButtonLabel,prevMonthButtonLabel:Date.dp_locales.texts.prevMonthButtonLabel,prevYearButtonLabel:Date.dp_locales.texts.prevYearButtonLabel,nextButtonLabel:Date.dp_locales.texts.nextButtonLabel,nextMonthButtonLabel:Date.dp_locales.texts.nextMonthButtonLabel,nextYearButtonLabel:Date.dp_locales.texts.nextYearButtonLabel,changeMonthButtonLabel:Date.dp_locales.texts.changeMonthButtonLabel,changeYearButtonLabel:Date.dp_locales.texts.changeYearButtonLabel,changeRangeButtonLabel:Date.dp_locales.texts.changeRangeButtonLabel,closeButtonTitle:Date.dp_locales.texts.closeButtonTitle,closeButtonLabel:Date.dp_locales.texts.closeButtonLabel,onUpdate:function(value){},previous:null,next:null,theme:'default',modal:!1,inline:!1,gainFocusOnConstruction:!0,min:null,max:null}
Datepicker.prototype.initializeDate=function(){var val=this.$target.val();var date=val===''?new Date():this.parseDate(val);this.setDate(date,!0)}
Datepicker.prototype.getDate=function(){var val=this.$target.val();var date=val===''?new Date():this.parseDate(val);return date}
Datepicker.prototype.setDate=function(newDate,init){this.dateObj=newDate;init=(typeof init==='undefined')?!1:init;if(this.dateObj==null){this.$target.attr('aria-invalid',!0);this.$target.parents('.form-group').addClass('has-error');this.dateObj=new Date();this.dateObj.setHours(0,0,0,0)}
if(this.options.min!=null&&this.dateObj<this.options.min){this.$target.attr('aria-invalid',!0);this.$target.parents('.form-group').addClass('has-error');this.dateObj=this.options.min}else if(this.options.max!=null&&this.dateObj>this.options.max){this.$target.attr('aria-invalid',!0);this.$target.parents('.form-group').addClass('has-error');this.dateObj=this.options.max}
if(!init||this.$target.val()!=''){this.$target.val(this.format(this.dateObj))}
this.curYear=this.dateObj.getFullYear();this.year=this.curYear;this.curMonth=this.dateObj.getMonth();this.month=this.curMonth;this.date=this.dateObj.getDate();switch(this.options.startView){case 1:this.populateMonthsCalendar();this.$grid.attr('aria-activedescendant',this.$grid.find('.curMonth').attr('id'));break;case 2:this.populateYearsCalendar();this.$grid.attr('aria-activedescendant',this.$grid.find('.curYear').attr('id'));break;default:this.populateDaysCalendar();this.$grid.attr('aria-activedescendant',this.$grid.find('.curDay').attr('id'))}}
Datepicker.prototype.drawCalendarHeader=function(){var $days=this.$grid.find('th.datepicker-day');var weekday=this.options.firstDayOfWeek;for(var i=0;i<7;i++){$days.eq(i).attr('aria-label',this.locales.day_names[weekday])
$days.children('abbr').eq(i).attr('title',this.locales.day_names[weekday]).text(this.options.weekDayFormat==='short'?this.locales.day_names_short[weekday]:this.locales.day_names_narrow[weekday]);weekday=(weekday+1)%7}}
Datepicker.prototype.populateDaysCalendar=function(){this.$calendar.find('.datepicker-bn-prev-label').html(this.options.prevButtonLabel);this.$calendar.find('.datepicker-bn-next-label').html(this.options.nextButtonLabel);this.$calendar.find('.datepicker-bn-fast-prev-label').html(this.options.prevMonthButtonLabel);this.$calendar.find('.datepicker-bn-fast-next-label').html(this.options.nextMonthButtonLabel);if(this.options.min!=null&&(this.year-1<this.options.min.getFullYear()||(this.year-1==this.options.min.getFullYear()&&this.month<this.options.min.getMonth()))){this.$fastprev.attr('title','');this.$fastprev.addClass('disabled');this.$fastprev.removeClass('enabled')}else{this.$fastprev.attr('title',this.options.prevMonthButtonLabel);this.$fastprev.addClass('enabled');this.$fastprev.removeClass('disabled')}
var previousMonth=this.previousMonth(this.year,this.month);if(this.options.min!=null&&(previousMonth.year<this.options.min.getFullYear()||(previousMonth.year==this.options.min.getFullYear()&&previousMonth.month<this.options.min.getMonth()))){this.$prev.attr('title','');this.$prev.addClass('disabled');this.$prev.removeClass('enabled')}else{this.$prev.attr('title',this.options.prevButtonLabel);this.$prev.addClass('enabled');this.$prev.removeClass('disabled')}
this.$monthObj.attr('title',this.options.changeMonthButtonLabel);var nextMonth=this.nextMonth(this.year,this.month);if(this.options.max!=null&&(nextMonth.year>this.options.max.getFullYear()||(nextMonth.year==this.options.max.getFullYear()&&nextMonth.month>this.options.max.getMonth()))){this.$next.attr('title','');this.$next.addClass('disabled');this.$next.removeClass('enabled')}else{this.$next.attr('title',this.options.nextButtonLabel);this.$next.addClass('enabled');this.$next.removeClass('disabled')}
if(this.options.max!=null&&(this.year+1>this.options.max.getFullYear()||(this.year+1==this.options.max.getFullYear()&&this.month>this.options.max.getMonth()))){this.$fastnext.attr('title','');this.$fastnext.addClass('disabled');this.$fastnext.removeClass('enabled')}else{this.$fastnext.attr('title',this.options.nextMonthButtonLabel);this.$fastnext.addClass('enabled');this.$fastnext.removeClass('disabled')}
this.showObject(this.$fastprev);this.showObject(this.$fastnext);var numDays=this.getDaysInMonth(this.year,this.month);var numPrevDays=this.getDaysInMonth(previousMonth.year,previousMonth.month);var startWeekday=new Date(this.year,this.month,1).getDay();var lastDayOfWeek=(this.options.firstDayOfWeek+6)%7;var curDay=1;var rowCount=1;this.$monthObj.html(this.locales.month_names[this.month]+' '+this.year);this.showObject(this.$grid.find('thead'));var gridCells='\t<tr id="row0-'+this.id+'" role="row">\n';var numEmpties=0;var weekday=this.options.firstDayOfWeek;while(weekday!=startWeekday){numEmpties++;weekday=(weekday+1)%7}
for(;numEmpties>0;numEmpties--){gridCells+='\t\t<td class="empty">'+(numPrevDays-numEmpties+1)+'</td>\n'}
var isYearDisabled=this.options.isYearDisabled&&this.options.isYearDisabled(this.year);var isMonthDisabled=this.options.isMonthDisabled&&this.options.isMonthDisabled(this.year,this.month+1);for(curDay=1;curDay<=numDays;curDay++){var date=new Date(this.year,this.month,curDay,0,0,0,0);var longdate=this.formatDate(date,this.options.titleFormat);var curDayClass=curDay==this.date&&this.month==this.curMonth&&this.year==this.curYear?' curDay':'';if(isYearDisabled||isMonthDisabled){gridCells+='\t\t<td id="cell'+curDay+'-'+this.id+'" class="day unselectable'+curDayClass+'"'}else if($.inArray(weekday,this.options.daysOfWeekDisabled)>-1){gridCells+='\t\t<td id="cell'+curDay+'-'+this.id+'" class="day unselectable'+curDayClass+'"'}else if(this.options.min!=null&&date<this.options.min){gridCells+='\t\t<td id="cell'+curDay+'-'+this.id+'" class="day unselectable'+curDayClass+'"'}else if(this.options.max!=null&&date>this.options.max){gridCells+='\t\t<td id="cell'+curDay+'-'+this.id+'" class="day unselectable'+curDayClass+'"'}else if($.inArray(this.format(date),this.options.datesDisabled)>-1){gridCells+='\t\t<td id="cell'+curDay+'-'+this.id+'" class="day unselectable'+curDayClass+'"'}else if(this.options.isDateDisabled&&this.options.isDateDisabled(date)){gridCells+='\t\t<td id="cell'+curDay+'-'+this.id+'" class="day unselectable'+curDayClass+'"'}else{gridCells+='\t\t<td id="cell'+curDay+'-'+this.id+'" class="day selectable'+curDayClass+'"'}
gridCells+=' data-value="'+curDay+'"';gridCells+=' title="'+longdate+'"';gridCells+=' aria-label="'+longdate+'"';gridCells+=' headers="day'+weekday+'-header-'+this.id+'" role="gridcell" tabindex="-1" aria-selected="false">'+curDay;gridCells+='</td>';if(weekday==lastDayOfWeek&&curDay<numDays){gridCells+='\t</tr>\n\t<tr id="row'+rowCount+'-'+this.id+'" role="row">\n';rowCount++}
if(curDay<numDays){weekday=(weekday+1)%7}}
while(weekday!=lastDayOfWeek){gridCells+='\t\t<td class="empty">'+(++numEmpties)+'</td>\n';weekday=(weekday+1)%7}
gridCells+='\t</tr>';var $tbody=this.$grid.find('tbody');$tbody.empty();$tbody.append(gridCells);this.gridType=0}
Datepicker.prototype.populateMonthsCalendar=function(){this.$calendar.find('.datepicker-bn-prev-label').html(this.options.prevMonthButtonLabel);this.$calendar.find('.datepicker-bn-next-label').html(this.options.nextMonthButtonLabel);this.hideObject(this.$fastprev);this.hideObject(this.$fastnext);if(this.options.min!=null&&this.year-1<this.options.min.getFullYear()){this.$prev.attr('title','');this.$prev.addClass('disabled');this.$prev.removeClass('enabled')}else{this.$prev.attr('title',this.options.prevMonthButtonLabel);this.$prev.addClass('enabled');this.$prev.removeClass('disabled')}
this.$monthObj.attr('title',this.options.changeYearButtonLabel);if(this.options.max!=null&&this.year+1>this.options.max.getFullYear()){this.$next.attr('title','');this.$next.addClass('disabled');this.$next.removeClass('enabled')}else{this.$next.attr('title',this.options.nextMonthButtonLabel);this.$next.addClass('enabled');this.$next.removeClass('disabled')}
var curMonth=0;var rowCount=1;var $tbody=this.$grid.find('tbody');this.$monthObj.html(this.year);this.hideObject(this.$grid.find('thead'));$tbody.empty();$('#datepicker-err-msg-'+this.id).empty();var gridCells='\t<tr id="row0-'+this.id+'" role="row">\n';var isYearDisabled=this.options.isYearDisabled&&this.options.isYearDisabled(this.year);for(curMonth=0;curMonth<12;curMonth++){if(isYearDisabled){gridCells+='\t\t<td id="cell'+(curMonth+1)+'-'+this.id+'" class="month unselectable"'}else if(curMonth==this.month&&this.year==this.curYear){gridCells+='\t\t<td id="cell'+(curMonth+1)+'-'+this.id+'" class="month curMonth selectable"'}else if(this.options.min!=null&&(this.year<this.options.min.getFullYear()||(this.year==this.options.min.getFullYear()&&curMonth<this.options.min.getMonth()))){gridCells+='\t\t<td id="cell'+(curMonth+1)+'-'+this.id+'" class="month unselectable"'}else if(this.options.max!=null&&(this.year>this.options.max.getFullYear()||(this.year==this.options.max.getFullYear()&&curMonth>this.options.max.getMonth()))){gridCells+='\t\t<td id="cell'+(curMonth+1)+'-'+this.id+'" class="month unselectable"'}else if(this.options.isMonthDisabled&&this.options.isMonthDisabled(this.year,curMonth+1)){gridCells+='\t\t<td id="cell'+(curMonth+1)+'-'+this.id+'" class="month unselectable"'}else{gridCells+='\t\t<td id="cell'+(curMonth+1)+'-'+this.id+'" class="month selectable"'}
gridCells+=' data-value="'+curMonth+'"';gridCells+=' title="'+this.locales.month_names[curMonth]+' '+this.year+'"';gridCells+=' aria-label="'+this.locales.month_names[curMonth]+' '+this.year+'"';gridCells+=' role="gridcell" tabindex="-1" aria-selected="false">'+this.locales.month_names_abbreviated[curMonth];gridCells+='</td>';if(curMonth==3||curMonth==7){gridCells+='\t</tr>\n\t<tr id="row'+rowCount+'-'+this.id+'" role="row">\n';rowCount++}}
gridCells+='\t</tr>';$tbody.append(gridCells);this.gridType=1}
Datepicker.prototype.populateYearsCalendar=function(){this.$calendar.find('.datepicker-bn-prev-label').html(this.options.prevYearButtonLabel);this.$calendar.find('.datepicker-bn-next-label').html(this.options.nextYearButtonLabel);this.hideObject(this.$fastprev);this.hideObject(this.$fastnext);if(this.options.min!=null&&this.year-20<this.options.min.getFullYear()){this.$prev.attr('title','');this.$prev.addClass('disabled');this.$prev.removeClass('enabled')}else{this.$prev.attr('title',this.options.prevYearButtonLabel);this.$prev.addClass('enabled');this.$prev.removeClass('disabled')}
this.$monthObj.attr('title',this.options.changeRangeButtonLabel);if(this.options.max!=null&&this.year+20>this.options.max.getFullYear()){this.$next.attr('title','');this.$next.addClass('disabled');this.$next.removeClass('enabled')}else{this.$next.attr('title',this.options.nextYearButtonLabel);this.$next.addClass('enabled');this.$next.removeClass('disabled')}
var startYear=Math.floor(this.year/10)*10;var endYear=startYear+19;var rowCount=1;var $tbody=this.$grid.find('tbody');this.$monthObj.html(startYear+'-'+endYear);this.hideObject(this.$grid.find('thead'));$tbody.empty();$('#datepicker-err-msg-'+this.id).empty();var gridCells='\t<tr id="row0-'+this.id+'" role="row">\n';for(var curYear=startYear;curYear<=endYear;curYear++){if(curYear==this.year){gridCells+='\t\t<td id="cell'+(curYear-startYear+1)+'-'+this.id+'" class="year curYear selectable"'}else if(this.options.min!=null&&(curYear<this.options.min.getFullYear())){gridCells+='\t\t<td id="cell'+(curYear-startYear+1)+'-'+this.id+'" class="year unselectable"'}else if(this.options.max!=null&&(curYear>this.options.max.getFullYear())){gridCells+='\t\t<td id="cell'+(curYear-startYear+1)+'-'+this.id+'" class="year unselectable"'}else if(this.options.isYearDisabled&&this.options.isYearDisabled(curYear)){gridCells+='\t\t<td id="cell'+(curYear-startYear+1)+'-'+this.id+'" class="year unselectable"'}else{gridCells+='\t\t<td id="cell'+(curYear-startYear+1)+'-'+this.id+'" class="year selectable"'}
gridCells+=' data-value="'+curYear+'"';gridCells+=' title="'+curYear+'"';gridCells+=' role="gridcell" tabindex="-1" aria-selected="false">'+curYear;gridCells+='</td>';var curPos=curYear-startYear;if(curPos==4||curPos==9||curPos==14){gridCells+='\t</tr>\n\t<tr id="row'+rowCount+'-'+this.id+'" role="row">\n';rowCount++}}
gridCells+='\t</tr>';$tbody.append(gridCells);this.gridType=2}
Datepicker.prototype.showDaysOfPrevMonth=function(offset){var previousMonth=this.previousMonth(this.year,this.month);if(this.options.min!=null&&(previousMonth.year<this.options.min.getFullYear()||(previousMonth.year==this.options.min.getFullYear()&&previousMonth.month<this.options.min.getMonth()))){return!1}
this.month=previousMonth.month;this.year=previousMonth.year;this.populateDaysCalendar();if(offset!=null){var numDays=this.getDaysInMonth(this.year,this.month);var day='cell'+(numDays-offset)+'-'+this.id;this.$grid.attr('aria-activedescendant',day);this.selectGridCell(day)}
return!0}
Datepicker.prototype.showDaysOfMonth=function(month){if(this.options.min!=null&&(this.year<this.options.min.getFullYear()||(this.year==this.options.min.getFullYear()&&month<this.options.min.getMonth()))){return!1}
if(this.options.max!=null&&(this.year>this.options.max.getFullYear()||(this.year==this.options.max.getFullYear()&&month>this.options.max.getMonth()))){return!1}
this.month=month;this.date=Math.min(this.date,this.getDaysInMonth(this.year,this.month));this.populateDaysCalendar();var $active=this.$grid.find("tbody td[data-value='"+this.date+"']");this.selectGridCell($active.attr('id'));return!0}
Datepicker.prototype.showMonthsOfPrevYear=function(offset){if(this.options.min!=null&&this.year-1<this.options.min.getFullYear()){return!1}
this.year--;this.populateMonthsCalendar();if(offset!=null){var month='cell'+(12-offset)+'-'+this.id;this.$grid.attr('aria-activedescendant',month);this.selectGridCell(month)}
return!0}
Datepicker.prototype.showMonthsOfYear=function(year){if(this.options.min!=null&&year<this.options.min.getFullYear()){return!1}
if(this.options.max!=null&&year>this.options.max.getFullYear()){return!1}
this.year=year;this.populateMonthsCalendar();var $active=this.$grid.find("tbody td[data-value='"+this.month+"']");this.$grid.attr('aria-activedescendant',$active.attr('id'));this.selectGridCell($active.attr('id'));return!0}
Datepicker.prototype.showYearsOfPrevRange=function(offset){if(this.options.min!=null&&this.year-20<this.options.min.getFullYear()){return!1}
this.year-=20;this.populateYearsCalendar();if(offset!=null){var year='cell'+(20-offset)+'-'+this.id;this.$grid.attr('aria-activedescendant',year);this.selectGridCell(year)}
return!0}
Datepicker.prototype.showDaysOfNextMonth=function(offset){var nextMonth=this.nextMonth(this.year,this.month);if(this.options.max!=null&&(nextMonth.year>this.options.max.getFullYear()||(nextMonth.year==this.options.max.getFullYear()&&nextMonth.month>this.options.max.getMonth()))){return!1}
this.month=nextMonth.month;this.year=nextMonth.year;this.populateDaysCalendar();if(offset!=null){var day='cell'+offset+'-'+this.id;this.$grid.attr('aria-activedescendant',day);this.selectGridCell(day)}
return!0}
Datepicker.prototype.showMonthsOfNextYear=function(offset){if(this.options.max!=null&&this.year+1>this.options.max.getFullYear()){return!1}
this.year++;this.populateMonthsCalendar();if(offset!=null){var month='cell'+offset+'-'+this.id;this.$grid.attr('aria-activedescendant',month);this.selectGridCell(month)}
return!0}
Datepicker.prototype.showYearsOfNextRange=function(offset){if(this.options.max!=null&&this.year+20>this.options.max.getFullYear()){return!1}
this.year+=20;this.populateYearsCalendar();if(offset!=null){var year='cell'+offset+'-'+this.id;this.$grid.attr('aria-activedescendant',year);this.selectGridCell(year)}
return!0}
Datepicker.prototype.showDaysOfPrevYear=function(){if(this.options.min!=null&&(this.year-1<this.options.min.getFullYear()||(this.year-1==this.options.min.getFullYear()&&this.month<this.options.min.getMonth()))){return!1}
this.year--;this.populateDaysCalendar();return!0}
Datepicker.prototype.showDaysOfNextYear=function(){if(this.options.max!=null&&(this.year+1>this.options.max.getFullYear()||(this.year+1==this.options.max.getFullYear()&&this.month>this.options.max.getMonth()))){return!1}
this.year++;this.populateDaysCalendar();return!0}
Datepicker.prototype.bindHandlers=function(){var self=this;this.$fastprev.click(function(e){return self.handleFastPrevClick(e)});this.$prev.click(function(e){return self.handlePrevClick(e)});this.$next.click(function(e){return self.handleNextClick(e)});this.$fastnext.click(function(e){return self.handleFastNextClick(e)});this.$monthObj.click(function(e){return self.handleMonthClick(e)});this.$monthObj.keydown(function(e){return self.handleMonthKeyDown(e)});this.$fastprev.keydown(function(e){return self.handleFastPrevKeyDown(e)});this.$prev.keydown(function(e){return self.handlePrevKeyDown(e)});this.$next.keydown(function(e){return self.handleNextKeyDown(e)});this.$fastnext.keydown(function(e){return self.handleFastNextKeyDown(e)});if(this.options.modal==!0){this.$close.click(function(e){return self.handleCloseClick(e)});this.$close.keydown(function(e){return self.handleCloseKeyDown(e)})}
this.$grid.keydown(function(e){return self.handleGridKeyDown(e)});this.$grid.keypress(function(e){return self.handleGridKeyPress(e)});this.$grid.focus(function(e){return self.handleGridFocus(e)});this.$grid.blur(function(e){return self.handleGridBlur(e)});this.$grid.delegate('td','click',function(e){return self.handleGridClick(this,e)});this.$target.change(function(e){var date=self.parseDate($(this).val());self.updateLinked(date)})}
Datepicker.prototype.handleFastPrevClick=function(e){if(this.showDaysOfPrevYear()){var active=this.$grid.attr('aria-activedescendant');if(this.month!=this.curMonth||this.year!=this.curYear){this.$grid.attr('aria-activedescendant','cell1'+'-'+this.id);this.selectGridCell('cell1'+'-'+this.id)}else{this.$grid.attr('aria-activedescendant',active);this.selectGridCell(active)}}
e.stopPropagation();return!1}
Datepicker.prototype.handlePrevClick=function(e){var active=this.$grid.attr('aria-activedescendant');switch(this.gridType){case 0:var ok;if(e.ctrlKey){ok=this.showDaysOfPrevYear()}else{ok=this.showDaysOfPrevMonth()}
if(ok){if(this.month!=this.curMonth||this.year!=this.curYear){this.$grid.attr('aria-activedescendant','cell1'+'-'+this.id);this.selectGridCell('cell1'+'-'+this.id)}else{this.$grid.attr('aria-activedescendant',active);this.selectGridCell(active)}}
break;case 1:if(this.showMonthsOfPrevYear()){if(this.year!=this.curYear){this.$grid.attr('aria-activedescendant','cell1'+'-'+this.id);this.selectGridCell('cell1'+'-'+this.id)}else{this.$grid.attr('aria-activedescendant',active);this.selectGridCell(active)}}
break;case 2:if(this.showYearsOfPrevRange()){this.$grid.attr('aria-activedescendant','cell1'+'-'+this.id);this.selectGridCell('cell1'+'-'+this.id)}
break}
e.stopPropagation();return!1}
Datepicker.prototype.handleMonthClick=function(e){this.changeGrid(e);e.stopPropagation();return!1}
Datepicker.prototype.handleNextClick=function(e){var active=this.$grid.attr('aria-activedescendant');switch(this.gridType){case 0:var ok;if(e.ctrlKey){ok=this.showDaysOfNextYear()}else{ok=this.showDaysOfNextMonth()}
if(ok){if(this.month!=this.curMonth||this.year!=this.curYear){this.$grid.attr('aria-activedescendant','cell1'+'-'+this.id);this.selectGridCell('cell1'+'-'+this.id)}else{this.$grid.attr('aria-activedescendant',active);this.selectGridCell(active)}}
break;case 1:if(this.showMonthsOfNextYear()){if(this.year!=this.curYear){this.$grid.attr('aria-activedescendant','cell1'+'-'+this.id);this.selectGridCell('cell1'+'-'+this.id)}else{this.$grid.attr('aria-activedescendant',active);this.selectGridCell(active)}}
break;case 2:if(this.showYearsOfNextRange()){this.$grid.attr('aria-activedescendant','cell1'+'-'+this.id);this.selectGridCell('cell1'+'-'+this.id)}
break}
e.stopPropagation();return!1}
Datepicker.prototype.handleFastNextClick=function(e){if(this.showDaysOfNextYear()){var active=this.$grid.attr('aria-activedescendant');if(this.month!=this.curMonth||this.year!=this.curYear){this.$grid.attr('aria-activedescendant','cell1'+'-'+this.id);this.selectGridCell('cell1'+'-'+this.id)}else{this.$grid.attr('aria-activedescendant',active);this.selectGridCell(active)}}
e.stopPropagation();return!1}
Datepicker.prototype.handleCloseClick=function(e){this.hide();e.stopPropagation();return!1}
Datepicker.prototype.handleFastPrevKeyDown=function(e){if(e.altKey){return!0}
switch(e.keyCode){case this.keys.tab:{if(this.options.modal==!1||e.ctrlKey){return!0}
if(e.shiftKey){this.$close.focus()}else{this.$prev.focus()}
e.stopPropagation();return!1}
case this.keys.enter:case this.keys.space:{if(e.shiftKey||e.ctrlKey){return!0}
this.showDaysOfPrevYear();e.stopPropagation();return!1}
case this.keys.esc:{this.hide();e.stopPropagation();return!1}}
return!0}
Datepicker.prototype.handlePrevKeyDown=function(e){if(e.altKey){return!0}
switch(e.keyCode){case this.keys.tab:{if(this.options.modal==!1||e.ctrlKey){return!0}
if(e.shiftKey){if(this.gridType==0){this.$fastprev.focus()}else{this.$close.focus()}}else{this.$monthObj.focus()}
e.stopPropagation();return!1}
case this.keys.enter:case this.keys.space:{if(e.shiftKey){return!0}
switch(this.gridType){case 0:if(e.ctrlKey){this.showDaysOfPrevYear()}else{this.showDaysOfPrevMonth()}
break;case 1:this.showMonthsOfPrevYear();break;case 2:this.showYearsOfPrevRange();break}
e.stopPropagation();return!1}
case this.keys.esc:{this.hide();e.stopPropagation();return!1}}
return!0}
Datepicker.prototype.handleMonthKeyDown=function(e){if(e.altKey){return!0}
switch(e.keyCode){case this.keys.tab:{if(this.options.modal==!1||e.ctrlKey){return!0}
if(e.shiftKey){this.$prev.focus()}else{this.$next.focus()}
e.stopPropagation();return!1}
case this.keys.enter:case this.keys.space:{this.changeGrid(e);e.stopPropagation();return!1}
case this.keys.esc:{this.hide();e.stopPropagation();return!1}}
return!0}
Datepicker.prototype.handleNextKeyDown=function(e){if(e.altKey){return!0}
switch(e.keyCode){case this.keys.tab:{if(this.options.modal==!1||e.ctrlKey){return!0}
if(e.shiftKey){this.$monthObj.focus()}else{if(this.gridType==0){this.$fastnext.focus()}else{this.$grid.focus()}}
e.stopPropagation();return!1}
case this.keys.enter:case this.keys.space:{switch(this.gridType){case 0:if(e.ctrlKey){this.showDaysOfNextYear()}else{this.showDaysOfNextMonth()}
break;case 1:this.showMonthsOfNextYear();break;case 2:this.showYearsOfNextRange();break}
e.stopPropagation();return!1}
case this.keys.esc:{this.hide();e.stopPropagation();return!1}}
return!0}
Datepicker.prototype.handleFastNextKeyDown=function(e){if(e.altKey){return!0}
switch(e.keyCode){case this.keys.tab:{if(this.options.modal==!1||e.ctrlKey){return!0}
if(e.shiftKey){this.$next.focus()}else{this.$grid.focus()}
e.stopPropagation();return!1}
case this.keys.enter:case this.keys.space:{this.showDaysOfNextYear();e.stopPropagation();return!1}
case this.keys.esc:{this.hide();e.stopPropagation();return!1}}
return!0}
Datepicker.prototype.handleCloseKeyDown=function(e){if(e.altKey){return!0}
switch(e.keyCode){case this.keys.tab:{if(e.ctrlKey){return!0}
if(e.shiftKey){this.$grid.focus()}else{if(this.gridType==0){this.$fastprev.focus()}else{this.$prev.focus()}}
e.stopPropagation();return!1}
case this.keys.enter:case this.keys.esc:case this.keys.space:{if(e.shiftKey||e.ctrlKey){return!0}
this.hide();e.stopPropagation();return!1}}
return!0}
Datepicker.prototype.handleGridKeyDown=function(e){var $curCell=$('#'+this.$grid.attr('aria-activedescendant'));var $cells=this.$grid.find('td.selectable');var colCount=this.$grid.find('tbody tr').eq(0).find('td').length;if(e.altKey&&e.keyCode!=this.keys.pageup&&e.keyCode!=this.keys.pagedown){return!0}
switch(e.keyCode){case this.keys.tab:{if(this.options.modal==!0){if(e.shiftKey){if(this.gridType==0){this.$fastnext.focus()}else{this.$next.focus()}}else{this.$close.focus()}
e.stopPropagation()
return!1}else{this.hide();this.handleTabOut(e);e.stopPropagation();return!1}
break}
case this.keys.enter:case this.keys.space:{if(e.ctrlKey){return!0}
switch(this.gridType){case 0:this.update();this.hide();break;case 1:this.showDaysOfMonth(parseInt($curCell.attr('data-value'),10));break;case 2:this.showMonthsOfYear(parseInt($curCell.attr('data-value'),10));break}
e.stopPropagation();return!1}
case this.keys.esc:{this.hide();e.stopPropagation();return!1}
case this.keys.left:case this.keys.right:{if((e.keyCode==this.keys.left&&this.locales.directionality==='LTR')||(e.keyCode==this.keys.right&&this.locales.directionality==='RTL')){if(e.ctrlKey||e.shiftKey){return!0}
var cellIndex=$cells.index($curCell)-1;var $prevCell=null;if(cellIndex>=0){$prevCell=$cells.eq(cellIndex);this.unSelectGridCell($curCell.attr('id'));this.$grid.attr('aria-activedescendant',$prevCell.attr('id'));this.selectGridCell($prevCell.attr('id'))}else{switch(this.gridType){case 0:this.showDaysOfPrevMonth(0);break;case 1:this.showMonthsOfPrevYear(0);break;case 2:this.showYearsOfPrevRange(0);break}}
e.stopPropagation();return!1}else{if(e.ctrlKey||e.shiftKey){return!0}
var cellIndex=$cells.index($curCell)+1;var $nextCell=null;if(cellIndex<$cells.length){$nextCell=$cells.eq(cellIndex);this.unSelectGridCell($curCell.attr('id'));this.$grid.attr('aria-activedescendant',$nextCell.attr('id'));this.selectGridCell($nextCell.attr('id'))}else{switch(this.gridType){case 0:this.showDaysOfNextMonth(1);break;case 1:this.showMonthsOfNextYear(1);break;case 2:this.showYearsOfNextRange(1);break}}
e.stopPropagation();return!1}}
case this.keys.up:{if(e.ctrlKey||e.shiftKey){return!0}
var cellIndex=$cells.index($curCell)-colCount;var $prevCell=null;if(cellIndex>=0){$prevCell=$cells.eq(cellIndex);this.unSelectGridCell($curCell.attr('id'));this.$grid.attr('aria-activedescendant',$prevCell.attr('id'));this.selectGridCell($prevCell.attr('id'))}else{cellIndex=colCount-1-$cells.index($curCell);switch(this.gridType){case 0:this.showDaysOfPrevMonth(cellIndex);break;case 1:this.showMonthsOfPrevYear(cellIndex);break;case 2:this.showYearsOfPrevRange(cellIndex);break}}
e.stopPropagation();return!1}
case this.keys.down:{if(e.ctrlKey||e.shiftKey){return!0}
var cellIndex=$cells.index($curCell)+colCount;var $nextCell=null;if(cellIndex<$cells.length){$nextCell=$cells.eq(cellIndex);this.unSelectGridCell($curCell.attr('id'));this.$grid.attr('aria-activedescendant',$nextCell.attr('id'));this.selectGridCell($nextCell.attr('id'))}else{cellIndex=colCount+1-($cells.length-$cells.index($curCell));switch(this.gridType){case 0:this.showDaysOfNextMonth(cellIndex);break;case 1:this.showMonthsOfNextYear(cellIndex);break;case 2:this.showYearsOfNextRange(cellIndex);break}}
e.stopPropagation();return!1}
case this.keys.pageup:{var active=this.$grid.attr('aria-activedescendant');if(e.shiftKey||e.ctrlKey){return!0}
e.preventDefault();var ok=!1;switch(this.gridType){case 0:if(e.altKey){e.stopImmediatePropagation();ok=this.showDaysOfPrevYear()}else{ok=this.showDaysOfPrevMonth()}
break;case 1:ok=this.showMonthsOfPrevYear();break;case 2:ok=this.showYearsOfPrevRange();break}
if(ok){if($('#'+active).attr('id')==undefined){var $lastCell=$cells.eq($cells.length-1);this.$grid.attr('aria-activedescendant',$lastCell.attr('id'));this.selectGridCell($lastCell.attr('id'))}else{this.selectGridCell(active)}}
e.stopPropagation();return!1}
case this.keys.pagedown:{var active=this.$grid.attr('aria-activedescendant');if(e.shiftKey||e.ctrlKey){return!0}
e.preventDefault();var ok=!1;switch(this.gridType){case 0:if(e.altKey){e.stopImmediatePropagation();ok=this.showDaysOfNextYear()}else{ok=this.showDaysOfNextMonth()}
break;case 1:ok=this.showMonthsOfNextYear();break;case 2:ok=this.showYearsOfNextRange();break}
if(ok){if($('#'+active).attr('id')==undefined){var $lastCell=$cells.eq($cells.length-1);this.$grid.attr('aria-activedescendant',$lastCell.attr('id'));this.selectGridCell($lastCell.attr('id'))}else{this.selectGridCell(active)}}
e.stopPropagation();return!1}
case this.keys.home:{if(e.ctrlKey||e.shiftKey){return!0}
var $firstCell=$cells.eq(0);this.unSelectGridCell($curCell.attr('id'));this.$grid.attr('aria-activedescendant',$firstCell.attr('id'));this.selectGridCell($firstCell.attr('id'));e.stopPropagation();return!1}
case this.keys.end:{if(e.ctrlKey||e.shiftKey){return!0}
var $lastCell=$cells.eq($cells.length-1);this.unSelectGridCell($curCell.attr('id'));this.$grid.attr('aria-activedescendant',$lastCell.attr('id'));this.selectGridCell($lastCell.attr('id'));e.stopPropagation();return!1}}
return!0}
Datepicker.prototype.handleGridKeyPress=function(e){if(e.altKey){return!0}
switch(e.keyCode){case this.keys.tab:case this.keys.enter:case this.keys.space:case this.keys.esc:case this.keys.left:case this.keys.right:case this.keys.up:case this.keys.down:case this.keys.pageup:case this.keys.pagedown:case this.keys.home:case this.keys.end:{e.stopPropagation();return!1}}
return!0}
Datepicker.prototype.handleGridClick=function(id,e){var $cell=$(id);if($cell.is('.empty')||$cell.is('.unselectable')){return!0}
this.$grid.find('.focus').removeClass('focus').attr('aria-selected','false').attr('tabindex',-1);switch(this.gridType){case 0:this.$grid.attr('aria-activedescendant',$cell.attr('id'));this.selectGridCell($cell.attr('id'));this.update();this.hide();break;case 1:this.showDaysOfMonth(parseInt($cell.attr('data-value'),10));break;case 2:this.showMonthsOfYear(parseInt($cell.attr('data-value'),10));break}
e.stopPropagation();return!1}
Datepicker.prototype.handleGridFocus=function(e){var active=this.$grid.attr('aria-activedescendant');if($('#'+active).attr('id')==undefined){var $cells=this.$grid.find('td.selectable');var $lastCell=$cells.eq($cells.length-1);this.$grid.attr('aria-activedescendant',$lastCell.attr('id'));this.selectGridCell($lastCell.attr('id'))}else{this.selectGridCell(active)}
return!0}
Datepicker.prototype.handleGridBlur=function(e){this.unSelectGridCell(this.$grid.attr('aria-activedescendant'));return!0}
Datepicker.prototype.handleTabOut=function(e){var fields=$('body').find('input:visible,textarea:visible,select:visible');var index=fields.index(this.$target);if(index>-1&&index<fields.length){if(e.shiftKey){if(index>0){index--}}else{if(index+1<fields.length){index++}}
fields.eq(index).focus()}
return!0}
Datepicker.prototype.changeGrid=function(e){switch(this.gridType){case 0:this.populateMonthsCalendar();if(this.year!=this.curYear){var $cells=this.$grid.find('td.selectable');this.$grid.attr('aria-activedescendant',$cells.eq(0).attr('id'))}else{this.$grid.attr('aria-activedescendant',this.$grid.find('.curMonth').attr('id'))}
this.selectGridCell(this.$grid.attr('aria-activedescendant'));break;case 2:if(e.shiftKey){this.year-=20}else{this.year+=20}
case 1:this.populateYearsCalendar();if(this.year!=this.curYear){var $cells=this.$grid.find('td.selectable');this.$grid.attr('aria-activedescendant',$cells.eq(0).attr('id'))}else{this.$grid.attr('aria-activedescendant',this.$grid.find('.curYear').attr('id'))}
this.selectGridCell(this.$grid.attr('aria-activedescendant'));break}
return!0}
Datepicker.prototype.selectGridCell=function(cellId){$('#'+cellId).addClass('focus').attr('aria-selected','true').attr('tabindex',0).focus()}
Datepicker.prototype.unSelectGridCell=function(cellId){$('#'+cellId).removeClass('focus').attr('aria-selected','false').attr('tabindex',-1)}
Datepicker.prototype.update=function(){var $curDay=$('#'+this.$grid.attr('aria-activedescendant'));var date=new Date(this.year,this.month,parseInt($curDay.attr('data-value'),10));var val=this.formatDate(date,this.options.outputFormat);this.$target.val(val);this.$target.removeAttr('aria-invalid');this.$target.parents('.form-group').removeClass('has-error');this.$target.trigger('change');if(this.options.onUpdate){this.options.onUpdate(val)}}
Datepicker.prototype.updateLinked=function(date){if(this.options.previous!==null&&this.options.previous.val()!==''){var previousDate=this.options.previous.datepicker('getDate');if(previousDate>date){var previousVal=this.formatDate(date,this.options.previous.datepicker('outputFormat'));this.options.previous.val(previousVal)}}
if(this.options.next!==null&&this.options.next.val()!==''){var nextDate=this.options.next.datepicker('getDate');if(nextDate<date){var nextVal=this.formatDate(date,this.options.next.datepicker('outputFormat'));this.options.next.val(nextVal)}}}
Datepicker.prototype.hideObject=function($element){$element.attr('aria-hidden',!0);$element.hide()}
Datepicker.prototype.showObject=function($element){$element.attr('aria-hidden',!1);$element.show()}
Datepicker.prototype.show=function(){var self=this;$('#'+self.id).trigger('ab.datepicker.opening',[self.id]);if(this.options.modal==!0){if(!this.modalEventHandler){this.modalEventHandler=function(e){self.$grid.focus();e.stopPropagation;return!1}}
$(document).on('click mousedown mouseup',this.modalEventHandler);this.greyOut(!0);var zIndex=parseInt($('#datepicker-overlay').css('z-index'),10)||40;this.$calendar.css('z-index',zIndex+1)}else{$(document).on('click',$.proxy(this.handleDocumentClick,this));this.$calendar.on('ab.datepicker.opening',function(e,id){if(id!=self.id){self.hide()}else{self.$grid.focus()}})}
this.$calendar.on('ab.datepicker.opened',function(e,id){if(id==self.id){self.$grid.focus()}});var groupOffsetTop=Math.max(0,Math.floor(this.$group.offset().top-this.$label.offset().top));var groupOffsetLeft=Math.max(0,Math.floor(this.$group.offset().left-this.$label.offset().left));var parentPaddingLeft=parseInt(this.$calendar.parent().css('padding-left'),10);var calendarHeight=this.$calendar.outerHeight();var groupTop=this.$group.offset().top;var groupLeft=this.$group.offset().left;var groupHeight=this.$group.outerHeight(!0);var roomBefore=Math.floor(groupTop-$(window).scrollTop());var roomAfter=Math.floor($(window).height()-(groupTop+groupHeight-$(window).scrollTop()));if(roomAfter<calendarHeight&&roomAfter<roomBefore){this.$calendar.addClass('above');this.$calendar.css({top:(groupOffsetTop-calendarHeight)+'px',left:(groupOffsetLeft+parentPaddingLeft)+'px'})}else{this.$calendar.addClass('below');this.$calendar.css({top:(groupHeight+groupOffsetTop)+'px',left:(groupOffsetLeft+parentPaddingLeft)+'px'})}
this.$calendar.attr('aria-hidden','false');this.$calendar.fadeIn();$('#'+self.id).trigger('ab.datepicker.opened',[self.id])}
Datepicker.prototype.refresh=function(){this.drawCalendarHeader();switch(this.gridType){case 0:this.populateDaysCalendar();break;case 1:this.populateMonthsCalendar();break;case 2:this.populateYearsCalendar();break}}
Datepicker.prototype.handleDocumentClick=function(e){if($(e.target).parents('#datepicker-calendar-'+this.id).length==0){this.hide();return!0}else{this.$grid.focus();e.stopPropagation;return!1}}
Datepicker.prototype.hide=function(omitSettingFocus){if(this.options.inline==!1){var self=this;if(this.options.modal==!0){if(this.modalEventHandler){$(document).off('click mousedown mouseup',this.modalEventHandler)}
this.greyOut(!1)}else{$(document).off('click',self.handleDocumentClick);this.$calendar.off('ab.datepicker.opening')}
this.$calendar.removeClass('above below');this.$calendar.attr('aria-hidden','true');this.$calendar.fadeOut();$('#'+self.id).trigger('ab.datepicker.closed',[self.id]);if(!omitSettingFocus){this.$target.focus()}}}
Datepicker.prototype.greyOut=function(on){var $overlay=$('#datepicker-overlay');if($overlay.length==0&&on){$('body').append('<div id="datepicker-overlay" class="datepicker-overlay"></div>');$overlay=$('#datepicker-overlay')}
if(on){$overlay.fadeIn(500)}else{$overlay.fadeOut(500)}}
Datepicker.prototype.absolutePosition=function(element){var top=0,left=0;if(element.getBoundingClientRect){var box=element.getBoundingClientRect();var body=document.body;var docElem=document.documentElement;var scrollTop=window.pageYOffset||docElem.scrollTop||body.scrollTop;var scrollLeft=window.pageXOffset||docElem.scrollLeft||body.scrollLeft;var clientTop=docElem.clientTop||body.clientTop||0;var clientLeft=docElem.clientLeft||body.clientLeft||0;top=Math.round(box.top+scrollTop-clientTop);left=Math.round(box.left+scrollLeft-clientLeft)}else{while(element){top=top+parseInt(element.offsetTop,10);left=left+parseInt(element.offsetLeft,10);element=element.offsetParent}}
return{top:top,left:left}}
Datepicker.prototype.getDaysInMonth=function(year,month){return 32-new Date(year,month,32).getDate()}
Datepicker.prototype.previousMonth=function(year,month){if(month==0){month=11;year--}else{month--}
return{year:year,month:month}}
Datepicker.prototype.nextMonth=function(year,month){if(month==11){month=0;year++}else{month++}
return{year:year,month:month}}
Datepicker.prototype.formatDate=function(date,format){var zeroPad=function(x){return(x<0||x>9?"":"0")+x};var getWeekOfMonth=function(date){return Math.ceil((date.getDate()-1-date.getDay())/7)};var getWeekOfYear=function(date){var onejan=new Date(date.getFullYear(),0,1);return Math.ceil((((date-onejan)/86400000)+onejan.getDay()+1)/7)};var getDayOfYear=function(date){var start=new Date(date.getFullYear(),0,0);return Math.floor((date-start)/86400000)};var getMillisecondsInDay=function(date){var date1=new Date(date.getTime());date1.setHours(0);return date-date1};var y=date.getFullYear()+"";var M=date.getMonth()+1;var d=date.getDate();var D=getDayOfYear(date);var E=date.getDay();var H=date.getHours();var m=date.getMinutes();var s=date.getSeconds();var w=getWeekOfYear(date);var W=getWeekOfMonth(date);var F=Math.floor(date.getDate()/7)+1;var Q=Math.ceil((date.getMonth()+1)/3);var era=date.getFullYear()<1?0:1;var values={"y":""+y,"yyyy":y,"yy":y.substring(2,4),"L":M,"LL":zeroPad(M),"LLL":this.locales.month_names_abbreviated[M-1],"LLLL":this.locales.month_names[M-1],"LLLLL":this.locales.month_names_narrow[M-1],"M":M,"MM":zeroPad(M),"MMM":this.locales.month_names_abbreviated[M-1],"MMMM":this.locales.month_names[M-1],"MMMMM":this.locales.month_names_narrow[M-1],"d":d,"dd":zeroPad(d),"D":D,"DD":D,"DDD":D,"A":Math.round(getMillisecondsInDay(date)*Math.pow(10,-2)),"AA":Math.round(getMillisecondsInDay(date)*Math.pow(10,-1)),"AAA":Math.round(getMillisecondsInDay(date)*Math.pow(10,0)),"AAAA":Math.round(getMillisecondsInDay(date)*Math.pow(10,1)),"AAAAA":Math.round(getMillisecondsInDay(date)*Math.pow(10,2)),"AAAAAA":Math.round(getMillisecondsInDay(date)*Math.pow(10,3)),"E":this.locales.day_names_abbreviated[E],"EE":this.locales.day_names_abbreviated[E],"EEE":this.locales.day_names_abbreviated[E],"EEEE":this.locales.day_names[E],"EEEEE":this.locales.day_names_narrow[E],"EEEEEE":this.locales.day_names_short[E],"e":E,"ee":E,"eee":this.locales.day_names_abbreviated[E],"eeee":this.locales.day_names[E],"eeeee":this.locales.day_names_narrow[E],"eeeeee":this.locales.day_names_short[E],"c":E,"cc":E,"ccc":this.locales.day_names_abbreviated[E],"cccc":this.locales.day_names[E],"ccccc":this.locales.day_names_narrow[E],"cccccc":this.locales.day_names_short[E],"F":F,"G":this.locales.era_names_abbreviated[era],"GG":this.locales.era_names_abbreviated[era],"GGG":this.locales.era_names_abbreviated[era],"GGGG":this.locales.era_names[era],"GGGGG":this.locales.era_names_narrow[era],"Q":Q,"QQ":zeroPad(Q),"QQQ":this.locales.quarter_names_abbreviated[Q-1],"QQQQ":this.locales.quarter_names[Q-1],"QQQQQ":this.locales.quarter_names_narrow[Q-1],"q":Q,"qq":zeroPad(Q),"qqq":this.locales.quarter_names_abbreviated[Q-1],"qqqq":this.locales.quarter_names[Q-1],"qqqqq":this.locales.quarter_names_narrow[Q-1],"H":H,"HH":zeroPad(H),"h":H==0?12:H>12?H-12:H,"hh":zeroPad(H==0?12:H>12?H-12:H),"K":H>11?H-12:H,"k":H+1,"KK":zeroPad(H>11?H-12:H),"kk":zeroPad(H+1),"a":H>11?this.locales.day_periods.pm:this.locales.day_periods.am,"m":m,"mm":zeroPad(m),"s":s,"ss":zeroPad(s),"w":w,"ww":zeroPad(w),"W":W,};return format.replace(/('[^']+'|y{1,4}|L{1,5}|M{1,5}|c{1,6}|d{1,2}|D{1,3}|E{1,6}|e{1,6}|F{1,1}|G{1,5}|Q{1,5}|q{1,5}|H{1,2}|h{1,2}|K{1,2}|k{1,2}|m{1,2}|s{1,2}|w{1,2}|W{1,1}|A{1,6})/g,function(mask){return mask.charAt(0)==="'"?mask.substr(1,mask.length-2):values[mask]||mask})}
Datepicker.prototype.createDateFromFormat=function(format,value){var extractInteger=function(str,pos,minlength,maxlength){for(var x=maxlength;x>=minlength;x--){var integer=str.substring(pos,pos+x);if(integer.length<minlength){return null}
if(/^\d+$/.test(integer)){return integer}}
return null};var skipName=function(names,pos){for(var i=0;i<names.length;i++){var name=names[i];if(value.substring(pos,pos+name.length).toLowerCase()==name.toLowerCase()){return name.length}}
return 0};var pos=0;var now=new Date();var year=now.getYear();var month=now.getMonth()+1;var date=1;var hh=0;var mm=0;var ss=0;var ampm="";var self=this;$.each(format.match(/(.).*?\1*/g),function(k,token){switch(token){case 'yyyy':year=extractInteger(value,pos,4,4);if(year!=null){pos+=year.length}
break;case 'yy':year=extractInteger(value,pos,2,2);if(year!=null){pos+=year.length}
break;case 'y':year=extractInteger(value,pos,2,4);if(year!=null){pos+=year.length}
break;case 'MMM':case 'LLL':month=0;for(var i=0;i<self.locales.month_names_abbreviated.length;i++){var month_name=self.locales.month_names_abbreviated[i];if(value.substring(pos,pos+month_name.length).toLowerCase()==month_name.toLowerCase()){month=i+1;pos+=month_name.length;break}}
break;case 'MMMM':case 'LLLL':month=0;for(var i=0;i<self.locales.month_names.length;i++){var month_name=self.locales.month_names[i];if(value.substring(pos,pos+month_name.length).toLowerCase()==month_name.toLowerCase()){month=i+1;pos+=month_name.length;break}}
break;case 'EEE':case 'EE':case 'E':case 'eee':pos+=skipName(self.locales.day_names_abbreviated,pos);break;case 'EEEE':case 'eeee':case 'cccc':pos+=skipName(self.locales.day_names,pos);break;case 'EEEEEE':case 'eeeeee':case 'cccccc':pos+=skipName(self.locales.day_names_short,pos);break;case 'MM':case 'M':case 'LL':case 'L':month=extractInteger(value,pos,token.length,2);if(month==null||(month<1)||(month>12)){return null}
pos+=month.length;break;case 'dd':case 'd':date=extractInteger(value,pos,token.length,2);if(date==null||(date<1)||(date>31)){return null}
pos+=date.length;break;case 'hh':case 'h':hh=extractInteger(value,pos,token.length,2);if(hh==null||(hh<1)||(hh>12)){return null}
pos+=hh.length;break;case 'HH':case 'H':hh=extractInteger(value,pos,token.length,2);if(hh==null||(hh<0)||(hh>23)){return null}
pos+=hh.length;break;case 'KK':case 'K':hh=extractInteger(value,pos,token.length,2);if(hh==null||(hh<0)||(hh>11)){return null}
pos+=hh.length;break;case 'kk':case 'k':hh=extractInteger(value,pos,token.length,2);if(hh==null||(hh<1)||(hh>24)){return null}
pos+=hh.length;hh--;break;case 'mm':case 'm':mm=extractInteger(value,pos,token.length,2);if(mm==null||(mm<0)||(mm>59)){return null}
pos+=mm.length;break;case 'ss':case 's':ss=extractInteger(value,pos,token.length,2);if(ss==null||(ss<0)||(ss>59)){return null}
pos+=ss.length;break;case 'a':var amlength=self.locales.day_periods.am.length;var pmlength=self.locales.day_periods.pm.length;if(value.substring(pos,pos+amlength)==self.locales.day_periods.am){ampm="AM";pos+=amlength}else if(value.substring(pos,pos+pmlength)==self.locales.day_periods.pm){ampm="PM";pos+=pmlength}else{return null}
break;default:if(value.substring(pos,pos+token.length)!=token){return null}else{pos+=token.length}}});if(pos!=value.length){return null}
if(year==null){return null}
if(year.length==2){if(year>50){year=1900+(year-0)}else{year=2000+(year-0)}}
if((month<1)||(month>12)){return null}
if(month==2){if(((year%4==0)&&(year%100!=0))||(year%400==0)){if(date>29){return null}}else{if(date>28){return null}}}
if((month==4)||(month==6)||(month==9)||(month==11)){if(date>30){return null}}
if(hh<12&&ampm=="PM"){hh=hh-0+12}else if(hh>11&&ampm=="AM"){hh-=12}
return new Date(year,month-1,date,hh,mm,ss)}
Datepicker.prototype.parseDate=function(value){var date=null;var self=this;$.each(this.options.inputFormat,function(i,format){date=self.createDateFromFormat(format,value);if(date!=null){return!1}});if(date==null){date=self.createDateFromFormat(this.options.outputFormat,value)}
return date}
Datepicker.prototype.min=function(value){if(value!=null){this.options.min=value instanceof Date?value:this.parseDate(value);if(this.options.min!=null&&value<this.options.min){this.$target.attr('aria-invalid',!0);this.$target.parents('.form-group').addClass('has-error');this.dateObj=this.options.min}
if(this.options.inline!=!1){this.refresh()}}
return this.options.min}
Datepicker.prototype.max=function(value){if(value!=null){this.options.max=value instanceof Date?value:this.parseDate(value);if(this.options.max!=null&&value>this.options.max){this.$target.attr('aria-invalid',!0);this.$target.parents('.form-group').addClass('has-error');this.dateObj=this.options.max}
if(this.options.inline!=!1){this.refresh()}}
return this.options.max}
Datepicker.prototype.theme=function(value){if(value!=null){this.$button.removeClass(this.options.theme);this.$calendar.removeClass(this.options.theme);this.options.theme=value;this.$button.addClass(this.options.theme);this.$calendar.addClass(this.options.theme)}
return this.options.theme}
Datepicker.prototype.firstDayOfWeek=function(value){if(value!=null){this.options.firstDayOfWeek=parseInt(value,10);if(this.options.inline==!1){this.drawCalendarHeader()}else{this.refresh()}}
return this.options.firstDayOfWeek}
Datepicker.prototype.daysOfWeekDisabled=function(value){if(value!=null){this.options.daysOfWeekDisabled=[];if(!$.isArray(value)){value=[value]}
var self=this;$.each(value,function(i,val){if(typeof val==='number'){self.options.daysOfWeekDisabled.push(val)}else if(typeof val==='string'){self.options.daysOfWeekDisabled.push(parseInt(val,10))}})}
return this.options.daysOfWeekDisabled}
Datepicker.prototype.weekDayFormat=function(value){if(value!=null){this.options.weekDayFormat=value;this.drawCalendarHeader()}
return this.options.weekDayFormat}
Datepicker.prototype.inputFormat=function(value){if(value!=null){if(!$.isArray(value)){value=[value]}
if(this.$target.attr('placeholder')==this.options.inputFormat[0]){this.$target.attr('placeholder',value[0])}
this.options.inputFormat=value}
return this.options.inputFormat}
Datepicker.prototype.outputFormat=function(value){if(value!=null){this.options.outputFormat=value}
return this.options.outputFormat}
Datepicker.prototype.modal=function(value){if(value!=null){this.options.modal=value;if(this.options.modal==!0){if(this.options.inline==!1){this.showObject(this.$calendar.find('.datepicker-close-wrap'));this.showObject(this.$calendar.find('.datepicker-bn-close-label'))}
this.$close=this.$calendar.find('.datepicker-close');this.$close.html(this.options.closeButtonTitle).attr('title',this.options.closeButtonLabel);this.$calendar.find('.datepicker-bn-close-label').html(this.options.closeButtonLabel);var self=this;this.$close.click(function(e){return self.handleCloseClick(e)});this.$close.keydown(function(e){return self.handleCloseKeyDown(e)})}else{this.hideObject(this.$calendar.find('.datepicker-close-wrap'));this.hideObject(this.$calendar.find('.datepicker-bn-close-label'))}}
return this.options.modal}
Datepicker.prototype.inline=function(value){if(value!=null){if(value!=!1){this.hideObject(this.$button);this.hideObject(this.$calendar.find('.datepicker-close-wrap'));this.hideObject(this.$calendar.find('.datepicker-bn-close-label'));var $container=typeof value==='string'?$('#'+value):value;$container.append(this.$calendar);this.$calendar.css({position:'relative',left:'0px',top:'0px'});this.options.inline=value;this.initializeDate();this.showObject(this.$calendar)}else{this.$target.parent().after(this.$calendar);this.showObject(this.$button);if(this.options.modal==!0){this.showObject(this.$calendar.find('.datepicker-close-wrap'));this.showObject(this.$calendar.find('.datepicker-bn-close-label'))}
if(this.$calendar.parent().css('position')==='static'){this.$calendar.parent().css('position','relative')}
this.$calendar.css({position:'absolute'});this.options.inline=value;this.hide()}}
return this.options.inline}
Datepicker.prototype.format=function(date){return this.formatDate(date,this.options.outputFormat)}
Datepicker.prototype.enable=function(){this.$button.removeClass('disabled');this.$button.attr('aria-disabled',!1);this.$button.attr('tabindex',0)}
Datepicker.prototype.disable=function(){this.hide();this.$button.addClass('disabled');this.$button.attr('aria-disabled',!0);this.$button.attr('tabindex',-1)}
Datepicker.prototype.datesDisabled=function(dates){this.options.datesDisabled=[];if(!$.isArray(dates)){dates=[dates]}
var self=this;$.each(dates,function(i,v){if(typeof v==='string'){var date=self.parseDate(v);if(date!==null){self.options.datesDisabled.push(self.format(date))}}else if(v instanceof Date&&!isNaN(v.valueOf())){self.options.datesDisabled.push(self.format(v))}})}
Datepicker.prototype.startview=function(view){switch(view){case 1:case 'months':this.options.startView=1;break;case 2:case 'years':this.options.startView=2;break;default:this.options.startView=0}}
Datepicker.prototype.setLocales=function(value){this.locales=value;this.options.inputFormat=[this.locales.short_format];this.options.outputFormat=this.locales.short_format;this.options.titleFormat=this.locales.full_format,this.options.firstDayOfWeek=this.locales.firstday_of_week;this.options.buttonTitle=this.locales.texts.buttonTitle;this.$button.find('span').attr('title',this.options.buttonTitle);this.options.buttonLabel=this.locales.texts.buttonLabel;this.options.prevButtonLabel=this.locales.texts.prevButtonLabel;this.options.prevMonthButtonLabel=this.locales.texts.prevMonthButtonLabel;this.options.prevYearButtonLabel=this.locales.texts.prevYearButtonLabel;this.options.nextButtonLabel=this.locales.texts.nextButtonLabel;this.options.nextMonthButtonLabel=this.locales.texts.nextMonthButtonLabel;this.options.nextYearButtonLabel=this.locales.texts.nextYearButtonLabel;this.options.changeMonthButtonLabel=this.locales.texts.changeMonthButtonLabel;this.options.changeYearButtonLabel=this.locales.texts.changeYearButtonLabel;this.options.changeRangeButtonLabel=this.locales.texts.changeRangeButtonLabel;this.options.closeButtonTitle=this.locales.texts.closeButtonTitle;this.options.closeButtonLabel=this.locales.texts.closeButtonLabel;this.options.calendarHelp=this.locales.texts.calendarHelp;this.drawCalendarHeader();if(this.locales.directionality==='RTL'){this.$grid.addClass('rtl')}else{this.$grid.removeClass('rtl')}}
var old=$.fn.datepicker
$.fn.datepicker=function(option,value){if(typeof option=='string'&&$(this).length==1){var data=$(this).eq(0).data('ab.datepicker');if(data)return data[option](value)}else{return this.each(function(){var $this=$(this);var data=$this.data('ab.datepicker');var options=$.extend({},Datepicker.DEFAULTS,$this.data(),typeof option=='object'&&option);if(!data)$this.data('ab.datepicker',(data=new Datepicker(this,options)));if(typeof option=='string')data[option](value)})}}
$.fn.datepicker.Constructor=Datepicker
$.fn.datepicker.noConflict=function(){$.fn.datepicker=old
return this}}))