$(document).ready(function () {

    //create accessible tooltip for each element
    $('#batchAnnouncePatientIEN').accessibleSimpleTooltipAria({
        simpletooltipText: $('#batchAnnounceDetailsPatientIENColumn').html(),
        simpletooltipPrefixClass: 'secondary'
    });
    $('#batchAnnounceDetailsSSN').accessibleSimpleTooltipAria({
        simpletooltipText: $('#batchAnnounceDetailsSSNColumn').html(),
        simpletooltipPrefixClass: 'secondary'
    });
    $('#batchAnnounceLastName').accessibleSimpleTooltipAria({
        simpletooltipText: $('#batchAnnounceDetailsLastNameColumn').html(),
        simpletooltipPrefixClass: 'secondary'
    });
    $('#batchAnnounceFirstName').accessibleSimpleTooltipAria({
        simpletooltipText: $('#batchAnnounceDetailsFirstNameColumn').html(),
        simpletooltipPrefixClass: 'secondary-left'
    });
    $('#batchAnnounceCompleted').accessibleSimpleTooltipAria({
        simpletooltipText: $('#batchAnnounceDetailsCompletedColumn').html(),
        simpletooltipPrefixClass: 'secondary-left'
    });

    //initial data table setup and call for the first recordset
    $.fn.dataTable.ext.errMode = 'none';

    VAP.common.setProcessingForDataTable('tblBatchAnnounceDetailReport');

    VAP.common.reportTable = $('#tblBatchAnnounceDetailReport').DataTable({
        destroy: true,
        searching: false,
        processing: true,
        serverSide: true,
        dom: 'liptipr',
        columnDefs: [
            {orderable: false, targets: [ 0, 1, 2, 3, 4 ]}
        ],
        ajax: "BatchManagerQuery.do_sec?getDetail=true&batchId=" + $('#batchId').html() + "&orgId=" + $('#orgId').html(), 
        language: {
            emptyTable: "No records found",
            loadingRecords: ""
        },
        lengthMenu: [ 10, 25, 50, 100, 250, 500 ],
        pageLength: 25
    });

    VAP.common.reportTable.on('draw', function () {
        VAP.common.addAriaToDataTable('tblBatchAnnounceDetailReport', VAP.common.reportTable);
    });
});