-- 2.5.0 update
INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'startDateEndDateField', 'Enter the date in MM/DD/YYYY format. Do not enter date in ''Start Date'' or ''End Date'' field to search for all dates.');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'authenticatingFacilityField', 'This field filters the report by authenticating facility. Field defaults to the location associated to a User''s VA User ID.');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'consentTypeField', 'This field filters the data within the resultant report by consent types (all, authorizations, revocations and or restrictions).');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'patientTypesField', 'This field filters the data to include or not include test patient data within the resultant report. By default, only Real Patients are selected.');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'authenticatingFacilityColumn', 'This column lists the authenticating facility. Report defaults to facilities in alphabetical order.');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'consentTypeColumn', 'This column provides the consent types (all, authorizations, revocations and or restrictions).');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'consentDirectiveSummaryReportTotalColumn', 'This column lists the total consents for the associated consent type within a facility. Totals can be updated to exclude or include test patients or specified timeframe.');

-- Consent Directive Detailed Report
INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'ssnField', 'Enter nine (9) numbers only with no hyphens to filter report by a specific Social Security Number. System defaults to blank field to search for all SSNs.');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'lastNameField', 'This field filters the resultant report by Last Name and is not case-sensitive.');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'firstNameField', 'This field filters the resultant report by First Name and is not case-sensitive.');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'vaVISNField', 'This field allows for customization of reports by VISN and Facilities. Select the button enter your facility choices.');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'enteredByField', 'This field filters the resultant report to display consents entered  by an individual (manual entry) or entered by a system (i.e., eBenefits).');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'consentDirectiveDetailedReportPatientTypes', 'By default, only Real Patients are searched for. Click dropdown to display All Patients or only Test Patients results.');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'ssnColumn', 'This column displays the Social Security Number (SSN) for individuals within this report.');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'lastNameColumn', 'This column displays the Last Name of the individual listed within this report.');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'firstNameColumn', 'This column displays the First Name of the individual listed within this report.');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'eventOccurredColumn', 'This column displays the timestamp (date and time) for when the event occurred. This is shown in Central Time.');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'consentTypeSansAllColumn', 'This column displays the consent types (authorization, revocations and or restrictions) and whether these are eHX or SSA consents.');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'enteredByManualOrSystemColumn', 'This column displays whether the consent was entered  by an individual (manual entry) or entered by a system (i.e., eBenefits).');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'consentDirectiveDetailedReportAuthenticatingFacilityColumn', 'This column displays the facility that authenticated the consent directive (as it may not be the Veteran''s preferred facility).');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'consentDirectiveDetailedReportAuthenticatingFacilityStationIdColumn', 'This column displays the Station ID for the Authenticating Facility.');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'visnForAuthenticatingFacilityColumn', 'This column displays the VISN associated to the authenticating facility.');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'optInDateColumn', 'This column displays the opt-in date as the date the authorization was entered  by an individual (manual entry) or entered by a system (i.e., eBenefits).');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'expirationDateColumn', 'This column shows the date the individual''s consent to share information expires.');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'expiringConsentDetailedReportConsentTypeColumn', 'This column displays the consent type as either eHX or SSA authorizations.');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'eHealthExchangeOrganizationField', 'This field reflects the organizations to which patient discovery messages were sent.');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'eHealthExchangeOrganizationColumn', 'This column displays organizations to which patient discovery messages were sent.');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'vaFacilityColumn', 'This column displays the VA facilities that sent the patient discovery messages.');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'uniqueRealPatientsCountColumn', 'This column displays the total number of unique real patients.');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'matchesFoundForRealPatientsCountColumn', 'This column displays the number of matches found for real patients.');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'failsForRealPatientsCountColumn', 'This column displays the number of fails for real patients.');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'uniqueTestPatientsCountColumn', 'This column displays the total number of unique test patients.');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'matchesFoundForTestPatientsCountColumn', 'This column displays the total matches found for test patients.');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'failsForTestPatientsCountColumn', 'This column displays the total match fails for test patients.');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'patientDiscoveryAuditReportSSNField', 'This field filters the resultant report by SSN. One or multiple SSNs, separated by comma, with no hyphens may be entered. Each SSN must be nine (9) numbers long. System defaults to blank field to search for all SSNs.');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'mpiResultsField', 'This field allows you to filter the resultant report by all, match found, or match failed.');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'recordsPerPageField', 'This field reflects the organizations to which patient discovery (announcement) messages were sent.');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'includeTestPatientsField', 'Select checkbox to include test patients in the resultant report.');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'sendingOrganizationColumn', 'This column displays the sending organization for the patient discovery message (announcement).');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'purposeOfUseColumn', 'This column displays the purpose of use (treatment, emergency, coverage).');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'receivingOrganizationColumn', 'This column displays the receiving organization for the patient discovery message (announcement).');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'explanationOfFailureColumn', 'This column provides an explanation of failure, for the announcement that failed.');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'detailsColumn', 'This column displays any additional details received.');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'eHealthExchangeAuthorizationColumn', 'This column displays the count of eHealth  Exchange Authorizations currently in an opt-in status for the associated facility.');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'eHealthExchangeSSAAuthorizationColumn', 'This column displays the total count of SSA Authorizations currently in an opt-in status for the associated facility.');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'eHealthExchangeAuthorizationProcessedTotal', 'This column displays the total count of eHealth Exchange Authorizations and SSA Authorizations currently in an opt-in status for the associated facility.');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'middleNameColumn', 'This column displays the middle name of the individual listed within this report.');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'optInPatientsReportOptInDateColumn', 'This column displays the opt-in date as date the authorization was entered  by an individual (manual entry) or entered by a system (i.e., eBenefits).');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'optInPatientsReportExpirationDateColumn', 'This column displays the expiration date for the authorization.');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'optInPatientsReportAuthenticatingFacilityColumn', 'This column displays the facility which manually entered the consent, or the Patient Preferred Facility for thoes entered by a system (i.e., eBenefits).');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'reasonsForDelayField', 'These checkboxes allow the user to filter the resultant report by reason(s) for delay.');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'daysSinceDelayedField', 'This field filters the data to limit the search based on age of the delayed status (i.e., >5 days, >10 days, >15 days, >30 days, etc).');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'delayedConsentSummaryReportConsentTypeField', 'This field filters the data within the resultant report by consent types.');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'delayedConsentSummaryReportAuthenticatingFacilityColumn', 'This column displays the facility of the user that authenticated the consent directive (which may not be the Veteran''s preferred facility).');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'delayedConsentSummaryReportTotalColumn', 'This column lists the total consents for the associated consent type within a facility. Totals can be updated to exclude or include test patients or specified timeframe.');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'multipleSSNsField', 'This field filters the resultant report by SSN. One or multiple SSNs, separated by comma, with no hyphens may be entered. Each SSN must be nine (9) numbers long. System defaults to blank field to search for all SSNs.');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'enteredDateColumn', 'This column displays the timestamp (Date and Time) for when the event occurred. This is shown in Central Time.');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'icnColumn', 'This column displays the unique patient identifier associated to the individual.');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'reasonsForDelayColumn', 'This column displays the reason(s) for delay (form not signed, form content altered, demographic changes, privacy officer review, signature verification, and power of attorney not on file).');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'delayedConsentDetailReportAuthenticatingFacilityColumn', 'This column displays the facility of the user that authenticated the consent directive (which may not be the Veteran''s preferred facility).');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'receivedEHealthExchangeDocumentsSummaryReportOrganizationField', 'This field allows for filtering by organizations from which VA received documents through eHealth Exchange.');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'receivedEHealthExchangeDocumentsReportOrganizationField', 'This field allows for filtering by organizations from which VA received documents through eHealth Exchange.');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'receivedEHealthExchangeDocumentsReportIncludeTestPatientsField', 'Use checkmark to include Test Patients in the results.');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'disclosureSourceField', 'Click to select the disclosure source either from Exchange (default) or Direct.');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'disclosuresSummaryReportOrganizationField', 'This field allows for filtering of the organizations to which the VA disclosed records.');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'accountingOfDisclosuresReportOrganizationField', 'This field allows for filtering of the organizations to which the VA disclosed records.');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'accountingOfDisclosuresReportIncludeTestPatientsField', 'Use checkmark to include Test Patients in the results.');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'disclosureDateField', 'This column displays the timestamp (date and time) for when the event occurred. This is shown in Central Time.');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'patientPreferredFacilityFilter', 'This field filters the report by patient''s preferred facility. If not explicitly set, the field defaults to the location associated with the user''s VA user ID.');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'accountingOfDisclosuresReportOrganization', 'This column displays the organizations to which the VA disclosed records.');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'auditsColumn', 'This column displays the number of audit transactions per partner by a VA facility.');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'messageColumn', 'This column displays type of logged patient discovery transaction (Add Patient Correlation, Check Policy, etc.)');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'disclosureColumn', 'This column displays the type of disclosure made.');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'disclosuresUserIdColumn', 'This column displays the User ID for the disclosures transaction.');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'patientSearchSSNField', 'Enter nine (9) numbers only with no hyphens to search for a patient by a specific Social security Number.');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'delayedConsentSummaryReportConsentTypeColumn', 'This column displays the consent types.');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'delayedConsentDetailReportSSNField', 'This field filters the resultant report by SSN. One or multiple SSNs, separated by comma, with no hyphens may be entered. Each SSN must be nine (9) numbers long. System defaults to blank field to search for all SSNs.');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'delayedConsentDetailReportConsentTypeColumn', 'This column displays the consent types.');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'purposeOfUseField', 'This field allows for filtering by purpose of use (treatment, emergency, coverage).');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'documentTitleColumn', 'This column displays the document title retrieved by the user.');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'receivedEHealthExchangeDocumentsReportFacilityWithDefaultField', 'This field allows for filtering by Patient Preferred Facility.  Default is the location associated with a User''s VA User ID.');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'receivedEHealthExchangeDocumentsReportOrganizationColumn', 'This column displays the organizations from which VA received documents through eHealth Exchange.');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'receivedEHealthExchangeDocumentsReportUserIdColumn', 'This column displays the User ID of the user who retrieved the data.');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'receivedEHealthExchangeDocumentsReportUserRoleColumn', 'This column displays the User Role of the user who retrieved the data.');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'disclosureSummaryReportOrganizationColumn', 'This column displays the organization to which the VA disclosed records.');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'disclosureReportFacilityColumn', 'This column displays the VA facilities that sent the patients disclosed records.');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'disclosureSummaryReportTotalColumn', 'This column lists the total disclosures for the associated organization and patient preferred facility. Totals can be updated to exclude or include test patients or specified timeframe.');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'receivedEHealthExchangeDocumentsSummaryReportOrganizationColumn', 'This column displays the organizations from which VA received documents through eHealth Exchange.');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'receivedEHealthExchangeDocumentsSummaryReportVAFacilityColumn', 'This column displays the VA Facility that received the documents through eHealth Exchange from the eHealth Exchange partner organization displayed to the left.');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'receivedEHealthExchangeDocumentsSummaryReportTotalColumn', 'This column displays the total count of documents from that organization received by the VA Facility.');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'disclosureDetailedReportUserRoleColumn', 'This column displays the role of the users (referred to as ''person class'') associated to the disclosure transaction.');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'consentDirectiveDetailedReportPatientSignatureDateColumn', 'This column displays the date of the Patient Signature associated with this Consent Directive or the date the Patient was Deceased.');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'consentDirectiveDetailedReportInactivationReasonColumn', 'This column displays the reason consent directive was inactivated, and can be one of the following: Revoked, Entered in Error, Authorization Expired, New Authorization, or Patient Deceased.');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'userIdField', 'Use this field to filter by partial or full ID of the user that entered or submitted the consent (e.g. ''eBenefits'', ''vha'').');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'delayedConsentDetailReportEnteredByColumn', 'This colum filters the resultant report to display consents entered  by an individual (manual entry) or entered by a system (i.e., eBenefits).');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'delayedConsentDetailReporMailedDatesColumn', 'This column displays the date(s) a consent letter was either marked as mailed, or a date that was manually entered as the date the consent letter was mailed.');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'delayedConsentDetailReportEnteredByField', 'Use this field to filter by partial or full ID of the user that entered delayed consent.');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'patientSearchFirstNameField', 'This field filters the Patient Search by First Name and is not case-sensitive.');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'patientSearchLastNameField', 'This field filters the Patient Search by Last Name and is not case-sensitive.');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'delayedConsentDetailReportConsentTypeField', 'This field filters the data within the resultant report by consent types.');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'reAnnounceCheckbox', 'Check box to re-announce patients who have authorized sharing and have been previously announced.');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'manageBatchesOrganizationField', 'This field allows for filtering of the organizations to which the VA disclosed records.');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'defaultFacilityField', 'This list allows the user to select the default facility setting. This default will be used as the default facility on filters for reports within the VAP application.');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'removeDefaultFacilityButton', 'This button removes the default facility presently selected.');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'expiringConsentNotificationFrequencyField', 'This field allows the user to set the frequency at which the system will automatically run notification details associated to expiring consent information for patients within a user specified expiration window.');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'expiringConsentNotificationDaysUntilExpirationField', 'The field allows for selection of timeframe (days until expiration) for notifications in regards to expiring consents.');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'expiringConsentNotificationDistributionListField', 'Email addresses can be entered within this field to receive the expiring consent notification based on frequency and days until expiration selected in fields above.');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'partnerOrganizationNameField', 'This field allows the admin to edit the partner organization''s name. This is a required field.');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'partnerOrganizationNumberField', 'This field allows the admin to edit the associated organization number. This is a required field.');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'partnerOrganizationContactNameField', 'This field allows the admin to edit the Point of Contact (POC) associated to the partner organization.');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'partnerOrganizationContactPhoneField', 'This field allows the admin to edit the Point of Contact (POC) phone number associated to the partner organization.');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'partnerOrganizationIsTrustedClinicalSourceField', 'This checkbox allows for selecting if a partner is a trusted clinical source, which will allow documentation received from that source to be automatically saved to the VHA health record without clinical review, such as with retail pharmacy immunization data that is automatically written to VistA.');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'partnerOrganizationActiveColumn', 'This column denotes if a partner organization is still an active partner.');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'partnerOrganizationPhoneColumn', 'This column displays the partner organization''s associated phone number on record.');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'partnerOrganizationPrefixColumn', 'This column displays the pre-fix associated to the partner organization''s OID.');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'partnerOrganizationConsumerOnlyColumn', 'This column denotes if a partner organization will only receive but not send health information (consumer only).');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'partnerOrganizationContactColumn', 'This column displays the point of contact for the partner organization.');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'partnerOrganizationDomainColumn', 'This column displays the partner organization''s domain information.');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'partnerOrganizationNameColumn', 'This column displays the partner organization name.');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'partnerOrganizationNumberColumn', 'This column displays the partner organization station number.');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'partnerOrganizationIdColumn', 'This column displays partner organizations'' unique organization identifier.');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'partnerOrganizationTrustedClinicalSourceColumn', 'This column denotes if a partner organization has been pre-approved to have data automatically written to the VHA health record (''trusted clinical source'').');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'partnerOrganizationActionColumn', 'This column allows you to navigate to the ''Edit'' page to modify selected attributes of this partner.');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'serviceAuditServiceField', 'This field allows filtering by VAP web services (Consent Management, Forms Storage, and XACML Context Handler).');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'serviceAuditMethodField', 'This field''s selection is narrowed based on selection of a service and allows user to select method.');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'serviceAuditAuthorizedField', 'This field allows for filtering of web service calls based on whether a current authorization is on file or not.');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'serviceAuditSuccessField', 'This field allows filtering of web service calls based on if call was successful.');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'serviceAuditDurationField', 'This field allows filtering of web service calls by duration ( >10ms, 50 ms, 100ms, 200ms, 500 ms).');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'serviceAuditWebServiceColumn', 'Column displays web service type (Consent Management, Form Storage or XACML Context Handler).');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'serviceAuditMethodColumn', 'This column displays web service method.');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'serviceAuditEventDateColumn', 'This column displays the timestamp (date and time) for when the event occurred. This is shown in Central Time.');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'serviceAuditIPAddressColumn', 'This column displays the IP address from which the web service call was made.');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'serviceAuditDomainColumn', 'This column displays the domain from which the web service call was received.');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'serviceAuditAuthorizedColumn', 'This column displays whether the call was authorized (yes or no).');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'serviceAuditSuccessColumn', 'This column displays if web service call was successful.');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'serviceAuditDurationColumn', 'This column displays the duration of the web service call, in milliseconds.');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'genericRecordsPerPageField', 'This field filters the report with the selected number of records to display on each page of the search.');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'batchAnnouncePatientsAllOrganizationsField', 'This field allows for the user to select one or more eHealth organizations to send batch announcements. Announcements are made to share patient identifiers, such as ICNs, with partner systems to facilitate data sharing. Only those partner systems that have allowed batch announces (set in the Partner Organization edit screen) are shown here.');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'batchAnnouncePatientsOrganizationsToAnnounceToField', 'This field allows for the user to all eHealth organizations to send batch announcements. Announcements are made to share patient identifiers, such as ICNs, with partner systems to facilitate data sharing.');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'batchAnnouncePatientsOptedInField', 'This radio button provides the option to announce all patients who have authorized sharing to a new eHealth Exchange organization within a specified timeframe (Start and End Date).');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'batchAnnouncePatientsInExcelOrCSVFileField', 'This radio button provides the option to announce all patients who have authorized sharing to a new eHealth Exchange, and are listed within the uploaded Excel or CSV file.');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'batchAnnouncePatientsFileNameField', 'This field shows the name of the Excel or CSV file that has been uploaded to use for batch announcements.');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'manageBatchesStartDateField', 'Enter the start date for the announcement search in the Start Date field in the format mm/dd/yyyy. This date reflects the earliest date of the announcements in the search. Leave this field and the End Date field blank to find all announcements regardless of their dates.');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'manageBatchesEndDateField', 'Enter the end date for the announcement in the End Date field in the format mm/dd/yyyy. This date reflects the last date of the announcements in the search. Leave this field and the Start Date field blank to find all announcements regardless of their dates.');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'manageBatchesEHealthOrganizationsField', 'This field allows for selection of an eHealth Exchange Organization to view the associated scheduled and completed batch announcements. You can only select one entry from the list. The default option for this list box is ''All'' so do not select a specific organization if you want to see all eHealth Exchange organizations in the report.');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'genericUserId', 'User ID field allows the user of the application to filter a report by either full or partial name of the entity associated with the transaction. This field can refer to either DVA User ID that entered a record (for example, ''smith''), or a system that initiated a transaction (for example, ''eBenefits''). Search on this field is case insensitive; that is, values of ''smith'' and ''SMITH'' will produce the same result set.');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'genericViewColumn', 'A View link at the end of each listing allows authorized users to review the actual record disclosed.');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'disclosureReportFacilityNumberColumn', 'This column displays the facility number for the patient''s preferred facility.');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'patientPreferredFacilityStationIdColumn', 'This column is the Station ID for the Patient Preferred Facility.');
-- 2.6.0 update
INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'setDefaultFacilityButton', 'Set Default Facility');

-- updated this one in 2.7.2
INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'batchAnnounceMoveAll', 'Add all organizations to the announcement list');
-- updated this one in 2.7.2
INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'batchAnnounceMoveSelectedRight', 'Add selected organizations to the announcement list');
-- updated this one in 2.7.2
INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'batchAnnounceMoveSelectedLeft', 'Remove selected organizations from the announcement list');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'batchAnnounceClear', 'Clear all selections');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'consentDirectiveSummaryAuthorizations', 'This column displays the total number of eHealth Exchange Authorizations for the given filtering criteria.');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'consentDirectiveSummaryRevocations', 'This column displays the total number of eHealth Exchange Authorization Revocations for the given filtering criteria.');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'consentDirectiveSummaryRestrictions', 'This column displays the total number of eHealth Exchange Restriction Authorizations for the given filtering criteria.');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'consentDirectiveSummaryRestrictionRevocations', 'This column displays the total number of eHealth Exchange Restriction Revocations for the given filtering criteria.');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'consentDirectiveSummarySSAAuthorizations', 'This column displays the total number of Social Security Administration Authorizations for the given filtering criteria.');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'consentDirectiveSummarySSARevocations', 'This column displays the total number of Social Security Administration Authorization Revocations for the given filtering criteria.');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'scheduledExportsReportColumn', 'This column displays the title of the scheduled report.');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'scheduledExportsFormatColumn', 'This column displays the format of the scheduled report - Excel or CSV.');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'scheduledExportsDateColumn', 'This column displays the date and time the report was scheduled to be exported.');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'scheduledExportsStatusColumn', 'This column indicates whether the scheduled export is still pending or ready to be downloaded.');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'scheduledExportsDownloadColumn', 'This column contains action buttons to download the exports that have been completed.');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'monthlyReceivedDocumentReportRemoteOrganizationColumn', 'This column displays the name of the partner organization that sent the clinical document.');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'monthlyReceivedDocumentReportUserColumn', 'This column displays the name of the user that initiated document retrieval.');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'monthlyReceivedDocumentReportCountColumn', 'This column displays the count of documents received by given user from given partner organization.');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'monthlyReceivedDocumentReportStartMonthYearField', 'This field allow you to select the month and year to filter report results by.');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'disclosuresDirectAddress', 'This column displayes the Direct address used to which the VA disclosed records.');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'disclosureSummaryReportFacilityColumn', 'This column displays the VA facility that sent the disclosed record.');
-- 2.7.0 update
INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'partnerOrganizationDescriptionColumn', 'This column displays the partner organization description.');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'partnerOrganizationDescriptionField', 'This field allows the admin to edit the partner organization description. This is a required field.');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'manageBatchesOrganizationHeader', 'This column displays the organization name.');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'manageBatchesDateHeader', 'This column displays the date created.');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'manageBatchesScheduledHeader', 'This column displays the number of scheduled batches.');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'manageBatchesCompletedHeader', 'This column displays the number of completed batches.');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'manageBatchesSizeHeader', 'This column displays the batch size.');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'manageBatchesActionHeader', 'This column contains the action button for the corresponding row.');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'manageBatchesCheckBoxHeader', 'Checkbox that allows to Check all (one or many can be checked below)');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'disclosureSummaryReportFacilityIDColumn', 'This column displays the facility id of the preferred facility.');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'viewFacilityStationNumber', 'This column displays the associated three or five digit Veteran''s Affairs facility number.');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'viewFacilityName', 'This column displays the Veteran''s Affairs facility name.');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'viewFacilityAddress', 'This column displays the facility address.');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'viewFacilityCity', 'This column displays the facility city.');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'viewFacilityState', 'This column displays the facility state.');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'viewFacilityZipCode', 'This column displays facility zip code.');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'viewFacilityPhoneNumber', 'This column displays the facility phone number.');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'viewFacilityVISN', 'This column displays the VISN associated to the facility.');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'viewFacilityParent', 'This column displays the parent of the associated facility. When selecting the aggregate button on summary reports, the totals of all the children facilities will be rolled up and added to Parent Facility counts. Relationship can be revised through the "Edit" action.');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'viewFacilityChildren', 'This column displays the children of the associated facility. When selecting the aggregate button on summary reports, all of the counts from children facilities are rolled up and aggregated to Parent Facility counts. This relationship can be revised through the "Edit" action.');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'viewFacilityAllowed', 'This column displays if a facility is allowed.');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'viewFacilityAction', 'This column displays the available actions for the corresponding facility.');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'editFacilityStationNumber', 'This field allows the user to edit the facility station number.');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'editFacilityDNS', 'This field allows the user to edit the facility DNS.');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'editFacilityName', 'This field allows the user to edit the facility name.');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'editFacilityAddress', 'This field allows the user to edit the facility address.');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'editFacilityCity', 'This field allows the user to edit the facility city.');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'editFacilityState', 'This field allows the user to edit the facility state.');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'editFacilityZipCode', 'This field allows the user to edit the facility zip code.');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'editFacilityPhoneNumber', 'This field allows the user to edit the facility phone number.');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'editFacilityVisn', 'This field allows the user to edit the facility visn.');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'editFacilityParentList', 'This field allows the user to select a parent facility.');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'editFacilityAllowed', 'This field allows the user to select if a facility is allowed or not.');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'actionType', 'This field allows for filtering of the resultant data within this report to include the counts of only received (inbound) documents from partners or disclosed (outbound) to partners, or both.');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'documentSizeOrgCol', 'This column displays the organizations from which VA has disclosed records or received records through eHealth Exchange.');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'loincCode', 'This column displays the results type (LOINC code) for the associated documents exchanged.');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'documentSizeTitle', 'This column displays the title of the documents exchanged.');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'documentSizeCount', 'This column displays the total count of documents exchanged for the associated results type and document title within the selected dates. ');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'documentSizeAverageSize', 'This column displays the average file size of the documents exchanged (in kb) for the associated results type and document title.');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'documentSizeMinimumSize', 'This column displays the file size of the smallest document (in kb) for the associated results type and document title.');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'documentSizeMaximumSize', 'This column displays the largest individual file size (in kb) for documents within the associated results type and document title.');
-- 3.0.0 update
INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'startDateEndDateTimeField', 'Enter a start and end time to filter the selected report by records between those two time frames. It is important to note the Veterans Authorization and Preferences (VAP) system times refer to Central Standard Time (CST).');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'disclosuresReportSendingOrganizationField', 'This field filters the Patient Discovery Audit report by organizations who have sent patient discovery messages. Note: Either the Received Organization or the Sender Organization filters can be used to search the reports, but both cannot be filtered. This is because for each transaction the other organization will always be Veterans Affairs.');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'disclosuresReportReceivingOrganizationField', 'This field filters the Patient Discovery Audit report by organizations who have received patient discovery messages. Note: Either the Received Organization or the Sender Organization filters can be used to search the reports, but both cannot be filtered. This is because for each transaction the other organization will always be Veterans Affairs.');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'receivedEHealthExchangeDocumentsReportUserFacilityNameColumn', 'This column displays the facility associated to the User''s ID on this transaction.');

-- 3.1.0 update
INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'advancedSchedulingReportName', 'This form field is a user-input field used to capture the name of an advanced scheduled reporting task. An example of this could be "Patient Discovery Audit Weekly Export Task."');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'advancedSchedulingReportingPeriod', 'This dropdown allows the user to specify the time frame of data that should be included in the export. For example, this be include data from the past day, past week, past month.');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'advancedSchedulingFrequencyWeeklyWeeks', 'This form field specifies the recurrence of this advanced scheduled task to be run on a weekly basis.');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'advancedSchedulingFrequencyWeeklyDayOfWeek', 'This dropdown specifies the recurrence of this advanced scheduled task to be run on every designated week on a certain day of the week. For example, this task can be set to run every two weeks on a Sunday.');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'advancedSchedulingFrequencyMonthlyMonths', 'This form field specifies the recurrence of this advanced scheduled task to be run on a monthly basis.');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'advancedSchedulingFrequencyMonthlyDayOfMonth', 'This dropdown specifies the recurrence of this advanced scheduled task to be run on a certain day of the month. For example, this task can be set to run every one month on the 1st day of the month.');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'advancedSchedulingEndDateAfterOccurrences', 'This form field requires the user to set an end for the recurrence of this advance scheduling task. Users must enter a numerical number between 1 and 30.');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'advancedSchedulingEndBy', 'This form field requires the user to set an end date for the recurrence of this advance scheduling task. Users may not schedule an advanced task to continue past six months.');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'advancedSchedulingSelectAllColumn', 'This checkbox allows the users to select all the checkboxes for the rows listed on this page at one time.');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'advancedSchedulingNameColumn', 'This column displays the user-entered name of an advanced scheduled reporting task.');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'advancedSchedulingTypeColumn', 'This column displays the report type for the associated advanced scheduled reporting task. For example, this may specify this task is associated to the Received eHealth Exchange Detailed report.');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'advancedSchedulingFormatColumn', 'This column displays the format of the advanced scheduled report export. Files can be exported in either Excel format or CSV format.');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'advancedSchedulingDateCreatedColumn', 'This column displays the timestamp the advanced scheduled task was created by a user. All times are recorded in the Veterans Authorization and Preferences (VAP) system using Central Standard Time (CST).');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'advancedSchedulingStartDateColumn', 'This column displays the start date of the advanced scheduled task.');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'advancedSchedulingEndDateColumn', 'This column displays the date advanced scheduled task is set to end.');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'advancedSchedulingFrequencyColumn', 'This column displays the frequency of this advanced scheduled task. A user is able to set a task to occur daily, weekly, monthly or a recurring specified setting.');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'advancedSchedulingLogStatusColumn', 'This column displays the status either completed, in progress, or failed of an advanced scheduled task.');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'advancedSchedulingLogFormatColumn', 'This column displays the format of the advanced scheduled report export. Files can be exported in either Excel format or CSV format.');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'advancedSchedulingLogRunStartDateColumn', 'This column displays the date and time of when the advanced scheduled task started.');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'advancedSchedulingLogRunEndDateColumn', 'This column displays the date and time of when the advanced scheduled task completed.');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'optInPatientsReportEntryDateColumn', 'This column displays the date a consent was entered into the VAP system.');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'manageBatchesRequestedHeader', 'This column displays the number of requrested batches.');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'partnerOrganizationIsBatchAnnounceEnabledField', 'This checkbox allows for selecting if a partner has batch announcing enabled.');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'partnerOrganizationIsBatchAnnounceEnabledColumn', 'This column denotes if a partner organization has batch announcing enabled.');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'patientDiscoveryReportStartDateField', 'Required Field: Enter the date in MM/DD/YYYY format.');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'patientDiscoveryReportEndDateField', 'Required Field: Enter the date in MM/DD/YYYY format.');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'patientDiscoverySummaryReportStartDateField', 'Required Field: Enter the date in MM/DD/YYYY format.');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'patientDiscoverySummaryReportEndDateField', 'Required Field: Enter the date in MM/DD/YYYY format.');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'dqExportSearchStartDateField', 'Required Field: Enter the date in MM/DD/YYYY format.');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'dqExportSearchEndDateField', 'Required Field: Enter the date in MM/DD/YYYY format.');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'manageBatchesFailedHeader', 'This column displays the number of failed requests.');

INSERT INTO VAP.DESCRIPTOR
(DESCRIPTOR_ID, NAME, TEXT)
VALUES
(VAP.HIBERNATE_SEQUENCE.NEXTVAL, 'batchAnnounceDetailsCompletedColumn', 'This column displays the request status of the announcement.');