CREATE TABLE VAP.MAIL_TEMPLATE
(
  MAIL_TEMPLATE_ID  NUMBER(19)                  NOT NULL,
  LETTER_TYPE_ID    NUMBER(19)                  NOT NULL,
  TEXT              CLOB
);


CREATE UNIQUE INDEX VAP.MAIL_TEMPLATE_PK ON VAP.MAIL_TEMPLATE
(MAIL_TEMPLATE_ID);

ALTER TABLE VAP.MAIL_TEMPLATE ADD (
  CONSTRAINT MAIL_TEMPLATE_PK
  PRIMARY KEY
  (MAIL_TEMPLATE_ID)
  USING INDEX VAP.MAIL_TEMPLATE_PK
  ENABLE VALIDATE);
