CREATE TABLE VAP.PATIENT_DOCUMENT_TYPE
(
  DOCUMENT_TYPE_ID  NUMBER,
  DOCUMENT_NAME     VARCHAR2(255 BYTE)
);


CREATE UNIQUE INDEX VAP.PATIENT_DOCUMENT_TYPE_PK ON VAP.PATIENT_DOCUMENT_TYPE
(DOCUMENT_TYPE_ID);

ALTER TABLE VAP.PATIENT_DOCUMENT_TYPE ADD (
  CONSTRAINT PATIENT_DOCUMENT_TYPE_PK
  PRIMARY KEY
  (DOCUMENT_TYPE_ID)
  USING INDEX VAP.PATIENT_DOCUMENT_TYPE_PK
  ENABLE VALIDATE);
