rem First, copy vap_devl config. files into VAP_CONFIG\vap directory, then...
rem set JAVA_HOME, DOMAIN_HOME, and VAP_OUT_FILE variables below as needed.

rem Uncomment and edit these two Maven lines for using standalone Apache Maven
rem set M3_HOME=C:\apache-maven-3.3.9
rem set PATH=%M3_HOME%\bin;$PATH

set DOMAIN_HOME=C:\Oracle\Middleware12\Oracle_Home\user_projects\domains\vap_domain
set VAP_CONFIG=%DOMAIN_HOME%\config
set CLASSPATH=%DOMAIN_HOME%\config\vap;%CLASSPATH%
set JAVA_HOME=C:\Progra~1\Java\JDK18~1.0_1
set JAVA_OPTIONS=-Djava.security.egd=file:/dev/./urandom -Dweblogic.security.SSL.minimumProtocolVersion=TLSv1 -Dgov.va.med.environment.servertype=weblogic -Dorg.owasp.esapi.resources=%VAP_CONFIG%/vap/esapi -Djava.util.logging.config.file=file://%VAP_CONFIG%/vap/logging.properties -Dlog4j.configuration=file://%VAP_CONFIG%/vap/log4j.xml -Dweblogic.log.Log4jLoggingEnabled=true -Dext.properties.dir=%VAP_CONFIG%/vap/ -Djavax.net.debug=true -Dssl.debug=true -Dweblogic.StdoutDebugEnabled=true -Xrunjdwp:transport=dt_socket,address=4000,server=y,suspend=n %JAVA_OPTIONS%
set USER_MEM_ARGS=-Xms512m -Xmx4096m
set JAVA_VENDOR=Sun
set DERBY_FLAG=false

if not exist %DOMAIN_HOME%\servers\AdminServer\logs\NUL mkdir %DOMAIN_HOME%\servers\AdminServer\logs

set VAP_OUT_FILE=%DOMAIN_HOME%\servers\AdminServer\logs\vap_devl.out

%DOMAIN_HOME%\bin\startWebLogic.cmd > %VAP_OUT_FILE% 2>&1
