#!/bin/bash
echo "Enter Deployed Version:"
read OLD
echo "Enter Environment Name:"
read NEW

if [ -z "$NEW" -o "$NEW" == "" ]; then
  NEW=$OLD
fi
	
unzip "nvap-$OLD.ear" "nvap-web-$OLD.war" -d nvap-$NEW
unzip "nvap-$NEW/nvap-web-$OLD.war" "WEB-INF/classes/gov/va/nvap/web/endpoints.properties" -d nvap-$NEW/nvap-web-$NEW
unzip "nvap-$NEW/nvap-web-$OLD.war" "WEB-INF/classes/web.properties" -d nvap-$NEW/nvap-web-$NEW
# Build number is put in here automatically now.
# unzip "nvap-$NEW/nvap-web-$OLD.war" "WEB-INF/static.properties" -d nvap-$NEW/nvap-web-$NEW

unzip "nvap-$OLD.ear"   "APP-INF/lib/nvap-client-$OLD.jar" -d nvap-$NEW
unzip "nvap-$OLD.ear"   "APP-INF/classes/log4j.xml" -d nvap-$NEW

unzip "nvap-$NEW/APP-INF/lib/nvap-client-$OLD.jar" "META-INF/direct.properties" -d nvap-$NEW/APP-INF/lib/nvap-client-$NEW

unzip "nvap-$OLD.ear" "nvap-server-$OLD.jar" -d nvap-$NEW
unzip "nvap-$NEW/nvap-server-$OLD.jar" "server.properties" -d nvap-$NEW/nvap-server-$NEW
unzip "nvap-$NEW/nvap-server-$OLD.jar" "email.properties" -d nvap-$NEW/nvap-server-$NEW
unzip "nvap-$NEW/nvap-server-$OLD.jar" "beanRefContext.xml" -d nvap-$NEW/nvap-server-$NEW

rm nvap-$NEW/nvap-server-$OLD.jar
rm nvap-$NEW/nvap-web-$OLD.war
rm nvap-$NEW/APP-INF/lib/nvap-client-$OLD.jar

