/**
 *
 */
package gov.va.nvap.service.dataquality;


import java.util.Date;
import java.util.Objects;


/**
 *
 * 
 */
public class DqTransmissionLogQueryRequest { 

    private Date runStartDate;
    private Date runEndDate;
    private String filename;   
    private String eventType;
    private String status;  
    
    public DqTransmissionLogQueryRequest() {
        super();
    }
    
    /**
     * Get the value of runStartDate
     *
     * @return the value of runStartDate
     */
    public Date getRunStartDate() {
        return runStartDate;
    }

    /**
     * Set the value of runStartDate
     *
     * @param runStartDate new value of runStartDate
     */
    public void setRunStartDate(Date runStartDate) {
        this.runStartDate = runStartDate;
    }
    
    /**
     * Get the value of runEndDate
     *
     * @return the value of runEndDate
     */
    public Date getRunEndDate() {
        return runEndDate;
    }

    /**
     * Set the value of runEndDate
     *
     * @param runEndDate new value of runEndDate
     */
    public void setRunEndDate(Date runEndDate) {
        this.runEndDate = runEndDate;
    }
    
    /**
     * Get the value of filename
     *
     * @return the value of filename
     */
    public String getFilename() {
        return filename;
    }

    /**
     * Set the value of filename
     *
     * @param filename new value of filename
     */
    public void setFilename(String filename) {
        this.filename = filename;
    }

    /**
     * Get the value of status
     *
     * @return the value of status
     */
    public String getStatus() {
        return status;
    }

    /**
     * Set the value of status
     *
     * @param status new value of status
     */
    public void setStatus(String status) {
        this.status = status;
    }

    /**
     * Get the value of eventType
     *
     * @return the value of eventType
     */
    public String getEventType() {
        return eventType;
    }

    /**
     * Set the value of eventType
     *
     * @param eventType new value of eventType
     */
    public void setEventType(String eventType) {
        this.eventType = eventType;
    }

    @Override
    public int hashCode() {
        int hash = 7;
        hash = 47 * hash + Objects.hashCode(this.runStartDate);
        hash = 47 * hash + Objects.hashCode(this.runEndDate);
        hash = 47 * hash + Objects.hashCode(this.filename);
        hash = 47 * hash + Objects.hashCode(this.eventType);
        hash = 47 * hash + Objects.hashCode(this.status);
        return hash;
    }

    @Override
    public boolean equals(Object obj) {
        if (this == obj) {
            return true;
        }
        if (obj == null) {
            return false;
        }
        if (getClass() != obj.getClass()) {
            return false;
        }
        final DqTransmissionLogQueryRequest other = (DqTransmissionLogQueryRequest) obj;
        if (!Objects.equals(this.filename, other.filename)) {
            return false;
        }
        if (!Objects.equals(this.eventType, other.eventType)) {
            return false;
        }
        if (!Objects.equals(this.status, other.status)) {
            return false;
        }
        if (!Objects.equals(this.runStartDate, other.runStartDate)) {
            return false;
        }
        if (!Objects.equals(this.runEndDate, other.runEndDate)) {
            return false;
        }
        return true;
    }   
    
    @Override
    public String toString() {
        return "DqTransmissionLogQueryRequest{" + "runStartDate=" + runStartDate + ", runEndDate=" + runEndDate + ", filename=" + filename + ", eventType=" + eventType + ", status=" + status + '}';
    }
    
}
