package gov.va.nvap.server.test.common.transformer;

import javax.xml.transform.ErrorListener;
import javax.xml.transform.TransformerException;

import org.slf4j.LoggerFactory;
import org.slf4j.Logger;

public class ConsoleTransformerErrorListener implements ErrorListener {

        private static final Logger LOG = LoggerFactory.getLogger(ConsoleTransformerErrorListener.class);

	@Override
	public void error(final TransformerException ex)
			throws TransformerException {
		if (ConsoleTransformerErrorListener.LOG.isErrorEnabled()) {
			ConsoleTransformerErrorListener.LOG.error("",ex);
		}
		throw new RuntimeException(ex);
	}

	@Override
	public void fatalError(final TransformerException ex)
			throws TransformerException {
		if (ConsoleTransformerErrorListener.LOG.isErrorEnabled()) {
			ConsoleTransformerErrorListener.LOG.error("",ex);
		}
		throw new RuntimeException(ex);
	}

	@Override
	public void warning(final TransformerException ex)
			throws TransformerException {
		if (ConsoleTransformerErrorListener.LOG.isErrorEnabled()) {
			ConsoleTransformerErrorListener.LOG.error("",ex);
		}
	}

}
