<%-- 
    Document   : batchAnnounceDetail
    Created on : Nov 21, 2016, 2:59:51 PM
    Author     : Johann Sonnenberg
--%>

<%@taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c"%>
<%@taglib uri="http://java.sun.com/jsp/jstl/fmt" prefix="fmt"%>

<script>
<c:import url="/resources/js/pageLevelIncludes/batchAnnounceDetail.js" />
</script>
<div class="hidden">
    <div id="batchAnnounceDetailsPatientIENColumn"><c:out value="${descriptors['batchAnnounceDetailsPatientIENColumn']}"/></div>
    <div id="batchAnnounceDetailsSSNColumn"><c:out value="${descriptors['batchAnnounceDetailsSSNColumn']}"/></div>
    <div id="batchAnnounceDetailsLastNameColumn"><c:out value="${descriptors['batchAnnounceDetailsLastNameColumn']}"/></div>
    <div id="batchAnnounceDetailsFirstNameColumn"><c:out value="${descriptors['batchAnnounceDetailsFirstNameColumn']}"/></div>
    <div id="batchAnnounceDetailsCompletedColumn"><c:out value="${descriptors['batchAnnounceDetailsCompletedColumn']}"/></div>
    <div id="batchId"><c:out value="${batchId}"/></div>
    <div id="orgId"><c:out value="${orgId}"/></div>
</div>
<div id="batchAnnounceDetailModalContent">
    <div class="row">
        <div class="col-xs-12 col-sm-12 col-md-12 col-lg-12">
            <div style="float:left; width:40%;"><p>
                Announcement Date: <fmt:formatDate pattern="MM/dd/yyyy hh:mm:ss a" value="${announcedDate}" />
            </p>
            <p>
                Announced To: <c:out value="${announcedToOrg}" />
            </p></div>
            <div class="alert alert-info" style="float:right; width:60%;">
                <b>Key</b>
                <p>eHealth Exchange Timed Out Error - Your request exceeded the maximum time <c:out value="${announceTimeout}" /> to complete. Try again with a smaller request.</p>
                <p>For all other errors, retry the request. If the error displays again, please speak with your system administrator.</p>
            </div>
        </div>
    </div>
    <div class="row">
        <div class="col-xs-12 col-sm-12 col-md-12 col-lg-12" style="overflow-y: scroll; height: 400px;">
            <table id="tblBatchAnnounceDetailReport" class="table table-striped" width="100%" cellspacing="0" role="presentation">
                <thead>
                    <tr role="row">
                        <th id="batchAnnouncePatientIEN" role="columnheader" class="text-center js-simple-tooltip"><span data-simpletooltip-target="tableheader">Patient IEN</span></th>
                        <th id="batchAnnounceDetailsSSN" role="columnheader" class="text-center js-simple-tooltip"><span data-simpletooltip-target="tableheader">SSN</span></th>
                        <th id="batchAnnounceLastName" role="columnheader" class="text-center js-simple-tooltip"><span data-simpletooltip-target="tableheader">Last Name</span></th>
                        <th id="batchAnnounceFirstName" role="columnheader" class="text-center js-simple-tooltip"><span data-simpletooltip-target="tableheader">First Name</span></th>
                        <th id="batchAnnounceCompleted" role="columnheader" class="text-center js-simple-tooltip"><span data-simpletooltip-target="tableheader">Completed</span></th>
                    </tr>
                </thead>
            </table>
        </div>
    </div>
</div>
