<%--
    Deprecated as of VAP 2.6.0
    Document   : optInReportResults
    Created on : Dec 2, 2014
    Author     : Irakli Kakushadze
--%>

<%@page import="gov.va.nvap.web.user.UserHelper"%>
<%@page contentType="text/html" pageEncoding="UTF-8"%>
<%@taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c" %>
<%@taglib uri="http://java.sun.com/jsp/jstl/fmt" prefix="fmt"%>
<%@taglib uri="http://java.sun.com/jsp/jstl/functions" prefix="fn"%>
<%@taglib tagdir="/WEB-INF/tags/cpp" prefix="cpp"%>
<%@taglib tagdir="/WEB-INF/tags/paginator" prefix="pg" %>

<%
    String userName = UserHelper.getUserName(request);
%>

<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">

<html lang="en">
    <head>
        <%@include file="metaCommon.jsp" %>
        <title>Veterans Authorization & Preferences Opt-In Patients Report</title>
    </head>
    <body>
        <jsp:include page="header.jsp">
            <jsp:param name="userName" value="<%=userName%>" />
        </jsp:include>
        <%@include file="patientLinkForm.jsp"%>
        <table border="0" cellpadding="0" cellspacing="0" width="100%" summary="table is used for layout purposes" id="main-content-table">
            <tbody>
                <tr>
                    <jsp:include page="leftMenu.jsp">
                        <jsp:param name="userName" value="<%=userName%>" />
                    </jsp:include>
                    <!-- START: PAGE CONTENT -->
                    <th scope="row" style="float: left; font-size: 0; height: 0;">VA Content</th>
                    <td id="content-va">
                        <a name="content-area"></a>
                        <!-- START: SITE NAME BAR -->
                        <p class="title-bar"><!-- START: SITE NAME -->Opt-In Patients Report<!-- END: SITE NAME --></p>
                        <cpp:errors />
                        <!-- END: SITE NAME BAR -->
                        <table border="0" cellpadding="0" cellspacing="0" width="100%" summary="table is used for layout purposes">
                            <tbody>
                                <tr>
                                    <th scope="row" style="float: left; font-size: 0; height: 0;">Main Content</th>
                                    <td id="content-main">
                                        <table width="100%" summary="This table is used for layout purposes">
                                            <!-- START: PAGE TITLE AREA -->
                                            <!-- END: PAGE TITLE AREA -->
                                            <tr>
                                                <th scope="row" style="float: left; font-size: 0; height: 0;">Report Content</th>
                                                <td>
                                                    <!-- START: REPORT RESULTS -->
                                                    <table SUMMARY="This table is for formatting purposes only.">
                                                        <tbody>
                                                            <tr>
                                                                <th scope="row" style="float: left; font-size: 0; height: 0;">Form Content</th>
                                                                <td style="float: left;">
                                                                    <% session.setAttribute("optInReport", "true"); %>
                                                                    <div>
                                                                        <form>
                                                                            <input name="exportToExcel" alt="Export to Excel"
                                                                                class="button" type="submit" value="Export to Excel"
                                                                                onclick="exportAlert();"/>
                                                                            <input name="exportToCsv" alt="Export to CSV"
                                                                                class="button" type="submit" value="Export to CSV"
                                                                                onclick="exportAlert();"/>
                                                                        </form>
                                                                    </div>
                                                                    <c:choose>
                                                                        <c:when test="${!empty expiringConsentReportResults}">
                                                                            <br/>
                                                                            <pg:paginator paginator="${paginator}" uri="OptInReportResults.do_sec" results="${expiringConsentReportResults}" />
                                                                            <br/>
                                                                            <table width="100%">
                                                                                <thead>
                                                                                    <tr class="hor-minimalist-c">
                                                                                        <th scope="col"><span id="ssnHeader" data-tooltip="<c:out value="${descriptors['ssnColumn']}" />">SSN</span></th>
                                                                                        <th scope="col"><span id="lastNameHeader" data-tooltip="<c:out value="${descriptors['lastNameColumn']}" />">Patient Last Name</span></th>
                                                                                        <th scope="col"><span id="firstNameHeader" data-tooltip="<c:out value="${descriptors['firstNameColumn']}" />">Patient First Name</span></th>
                                                                                        <th scope="col"><span id="middleNameHeader" data-tooltip="<c:out value="${descriptors['middleNameColumn']}" />">Patient Middle Name</span></th>
                                                                                        <th scope="col"><span id="entryDate"  data-tooltip="<c:out value="${descriptors['optInPatientsReportEntryDateColumn']}" />">Entry Date</span></th>
                                                                                        <th scope="col"><span id="optInDateHeader" data-tooltip="<c:out value="${descriptors['optInPatientsReportOptInDateColumn']}" />">Opt In Date</span></th>
                                                                                        <th scope="col"><span id="expDateHeader" data-tooltip="<c:out value="${descriptors['optInPatientsReportExpirationDateColumn']}" />">Expiration Date</span></th>
                                                                                        <th scope="col"><span id="consentTypeHeader" data-tooltip="<c:out value="${descriptors['consentTypeColumn']}" />">Consent Type</span></th>
                                                                                        <th scope="col"><span id="enteredByHeader" data-tooltip="<c:out value="${descriptors['enteredByManualOrSystemColumn']}" />">Entered By</span></th>
                                                                                        <th scope="col"><span id="authFacilityHeader" data-tooltip="<c:out value="${descriptors['optInPatientsReportAuthenticatingFacilityColumn']}" />" data-tooltip-position="left">Authenticating Facility</span></th>
                                                                                    </tr>
                                                                                    <tr class="hor-minimalist-c"  width="1500px">
                                                                                        <td><a href="OptInReportResults.do_sec?inboundSortValue=patientSSN&inboundSortDirection=ASC"><br><img alt="sort this column in ascending order" src="res/sort-ascending.jpg" border="0"/></a><a> - </a><a href="OptInReportResults.do_sec?inboundSortValue=patientSSN&inboundSortDirection=DESC"><img alt="sort this column in descending order" src="res/sort-descending.jpg" border="0"/></a></td>
                                                                                        <td><a href="OptInReportResults.do_sec?inboundSortValue=patientLastName&inboundSortDirection=ASC"><br><img alt="sort this column in ascending order" src="res/sort-ascending.jpg" border="0"/></a><a> - </a><a href="OptInReportResults.do_sec?inboundSortValue=patientLastName&inboundSortDirection=DESC"><img alt="sort this column in descending order" src="res/sort-descending.jpg" border="0"/></a></td>
                                                                                        <td><a href="OptInReportResults.do_sec?inboundSortValue=patientGivenName&inboundSortDirection=ASC"><br><img alt="sort this column in ascending order" src="res/sort-ascending.jpg" border="0"/></a><a> - </a><a href="OptInReportResults.do_sec?inboundSortValue=patientGivenName&inboundSortDirection=DESC"><img alt="sort this column in descending order" src="res/sort-descending.jpg" border="0"/></a></td>
                                                                                        <td><a href="OptInReportResults.do_sec?inboundSortValue=patientMiddleName&inboundSortDirection=ASC"><br><img alt="sort this column in ascending order" src="res/sort-ascending.jpg" border="0"/></a><a> - </a><a href="OptInReportResults.do_sec?inboundSortValue=patientMiddleName&inboundSortDirection=DESC"><img alt="sort this column in descending order" src="res/sort-descending.jpg" border="0"/></a></td>
                                                                                        <td><a href="OptInReportResults.do_sec?inboundSortValue=EntryDate&inboundSortDirection=ASC"><br><img alt="sort this column in ascending order" src="res/sort-ascending.jpg" border="0"/></a><a> - </a><a href="OptInReportResults.do_sec?inboundSortValue=EntryDate&inboundSortDirection=DESC"><img alt="sort this column in descending order" src="res/sort-descending.jpg" border="0"/></a></td>
                                                                                        <td><a href="OptInReportResults.do_sec?inboundSortValue=optInDate&inboundSortDirection=ASC"><br><img alt="sort this column in ascending order" src="res/sort-ascending.jpg" border="0"/></a><a> - </a><a href="OptInReportResults.do_sec?inboundSortValue=optInDate&inboundSortDirection=DESC"><img alt="sort this column in descending order" src="res/sort-descending.jpg" border="0"/></a></td>
                                                                                        <td><a href="OptInReportResults.do_sec?inboundSortValue=expirationDate&inboundSortDirection=ASC"><br><img alt="sort this column in ascending order" src="res/sort-ascending.jpg" border="0"/></a><a> - </a><a href="OptInReportResults.do_sec?inboundSortValue=expirationDate&inboundSortDirection=DESC"><img alt="sort this column in descending order" src="res/sort-descending.jpg" border="0"/></a></td>
                                                                                        <td><a href="OptInReportResults.do_sec?inboundSortValue=optInConsentTypeId&inboundSortDirection=ASC"><br><img alt="sort this column in ascending order" src="res/sort-ascending.jpg" border="0"/></a><a> - </a><a href="OptInReportResults.do_sec?inboundSortValue=optInConsentTypeId&inboundSortDirection=DESC"><img alt="sort this column in descending order" src="res/sort-descending.jpg" border="0"/></a></td>
                                                                                        <td><a href="OptInReportResults.do_sec?inboundSortValue=userId&inboundSortDirection=ASC"><br><img alt="sort this column in ascending order" src="res/sort-ascending.jpg" border="0"/></a><a> - </a><a href="OptInReportResults.do_sec?inboundSortValue=userId&inboundSortDirection=DESC"><img alt="sort this column in descending order" src="res/sort-descending.jpg" border="0"/></a></td>
                                                                                        <td><a href="OptInReportResults.do_sec?inboundSortValue=facilityName&inboundSortDirection=ASC"><br><img alt="sort this column in ascending order" src="res/sort-ascending.jpg" border="0"/></a><a> - </a><a href="OptInReportResults.do_sec?inboundSortValue=facilityName&inboundSortDirection=DESC"><img alt="sort this column in descending order" src="res/sort-descending.jpg" border="0"/></a></td>
                                                                                    </tr>
                                                                                </thead>
                                                                                <tbody>
                                                                                    <pg:forEach var="r" items="${expiringConsentReportResults}" varStatus="i" paginator="${paginator}">
                                                                                        <tr class="hor-minimalist-b">
                                                                                            <td nowrap><cpp:patientLink ssn="${r.ssn}" firstName="${r.firstName}" lastName="${r.lastName}" ssnMasked="${r.ssnMasked}" /></td>
                                                                                            <td><c:out value="${r.lastName}"/></td>
                                                                                            <td><c:out value="${r.firstName}"/></td>
                                                                                            <td><c:out value="${r.middleName}"/></td>
                                                                                            <td><fmt:formatDate pattern="MM/dd/yyyy" value="${r.optInEntryDate}"/></td>
                                                                                            <td><fmt:formatDate pattern="MM/dd/yyyy" value="${r.optInDate}"/></td>
                                                                                            <td><fmt:formatDate pattern="MM/dd/yyyy" value="${r.expirationDate}"/></td>
                                                                                            <td><c:out value="${r.consentTypeName}"/></td>
                                                                                            <td><c:out value="${r.userId}"/></td>
                                                                                            <td><c:out value="${r.facilityName}"/></td>
                                                                                        </tr>
                                                                                    </pg:forEach>
                                                                                </tbody>
                                                                            </table>
                                                                            <pg:paginator paginator="${paginator}" uri="OptInReportResults.do_sec" results="${expiringConsentReportResults}" />
                                                                        </c:when>
                                                                        <c:otherwise>
                                                                            No records were found.
                                                                        </c:otherwise>
                                                                    </c:choose>
                                                                </td>
                                                            </tr>
                                                        </tbody>
                                                    </table>
                                                    <!-- END: REPORT RESULTS -->
                                                </td>
                                            </tr>
                                        </table>
                                    </td>
                                </tr>
                            </tbody>
                        </table>
                        <!-- START: PAGE FOOTER -->
                        <%@include file="footer.jsp" %>
                        <!-- END: PAGE FOOTER -->
                        <!-- END: PAGE CONTENT -->
                    </td>
                </tr>
            </tbody>
        </table>
    </body>
</html>